
var c = document.getElementById("myCanvas");
var ctx = c.getContext("2d");

var c1 = document.getElementById("backCanvas");
var ctx1 = c1.getContext("2d");

var c2 = document.getElementById("frontCanvas");
var ctx2 = c2.getContext("2d");

var c3 = document.getElementById("frontCanvas2");
var ctx3 = c3.getContext("2d");
var firstButton;
var secondButton;


var tempButtons;
var clearTrack = 0;
var select = 0;

var ballButton;

var mute = false;
var score = 0;
var level = 1;
var timeLeft = true;
var printOnce1 = true;
var printOnce2 = true;
var clicked = false;
var toMove = false;
var trackTime = 0.5;
var canClick = true;
var forcedMatchReset = false;
var foundSecondaryMatch = false;

var chainCount = 0;
var maxChainCount = 0;

var foundSpecialMatch = false;
var didSwap = false;
var forcedMatchReset2 = false;
var clusters = [];
var showingHint = false;
var stopTimer = false;
var multiMatch = false;
var pausedButtonActive = false;
var chainScore = 0;
var comboAnimating = false;
var scoreAnimating = false;
var firstPlayCheck = false;
var highlightColor = 'red';//'#FFFF00';
var opacityShift = 30;
var highlightSize = 1;
var edgeOfBoard = false;
var moveBallList = [];
var moveBallsToEdgeRunning = false;
var addToTimerBoolean = true;
var superBallHold = null;
var superBallHold1 = null;
var superBallList = [];
var superBallPopAnimation = false;
var animateThreads = 0;
var pulseHint;
var timerColor = [255, 255, 0];

var constantFlashingTimer = false;
var changeTimerColor = false;
var changeColorCounter = 0;
var firstMultiMatch = true;
var superBallClusters = [];
var touchPositions = [];
var superBallListIndex = [];
var superBallClusterIndex = [];
var explosionList = [];
var disableScolling = false;
var trophyIndex = 0;

/**
 * A promise wrapper for requestAnimationFrame.
 * @returns {Promise} Resolves when requestAnimationFrame calls back
 */
 function promiseRAF() {
 	return new Promise(function (resolve, reject) {
 		requestAnimationFrame(resolve);
 	});
 }

 function Shape(x, y, x1, y1, image, shift){
 	this.x = x;
 	this.y = y;
 	this.x1 = x1;
 	this.y1 = y1;
 	this.image = image;
 	this.shift = shift;
 }

 var allShapes = [];
 var gridShapes = [[],[],[],[],[],[],[],[]];
 var clearShapes = [];
 var toDrawShapes = [];
 var images = [];
 var selectBalls = [];

 var destination1 = [];
 var destination2 = [];

 var breakBall1 = [];
 var breakBall2 = [];
 var newBallsToMatch = [];

 var start = true;
 var loop = 0;
 var firstSelect = false;
 var paused = true;
 var top = 180;
 var timeScale = 0.5;
 document.getElementById("timer").style.transform = "scaleY("+ timeScale + ")";
 var swapBack = false;
 var updateMassMoveBalls = false;
 var loop2 = 0;
 var waitForSwapBack = false;

 var newLevel = false;
 var startup = true;
 var touchedBall = false;
 var multiMatchAnimating = false;
 var lastTouch = null;

 var alreadyStarted = false;

 document.addEventListener("DOMContentLoaded", function(){
  // Handler when the DOM is fully loaded
  var imagesLoaded = document.getElementById("ball4").complete;
  if(imagesLoaded){
  	setTimeout(function(){
  		document.getElementById("progressBar").style.display = "none";
  		document.getElementById("mainWrap").style.opacity = "1";
  	}, 500);
  	
  	setTimeout(setupBoard, 550);

  }else{
  	setTimeout(function(){
  		document.getElementById("progressBar").style.display = "none";
  		document.getElementById("mainWrap").style.opacity = "1";
  	}, 800);
  	
  	setTimeout(setupBoard, 1000);
  }

});




 function resetGame(){

 	gridShapes = [[],[],[],[],[],[],[],[]];
 	requestAnimationFrame(restoreBoard);

 	start = false;
 	paused = false;
 	timeScale = 0.5;
 	startup = true;

 	newGame1();

 	if(!newLevel){
 		//console.log("not a new level");
 		score = 0;
 		timeScale = 0.5;
 		document.getElementById("level").innerHTML = "Level: " + level;
 		document.getElementById("score").innerHTML = "Score: " + score;

 		document.getElementById("timer").style.transform = "scaleY("+ timeScale + ")";
 		doTimer();
 		mainTheme = document.getElementById("maintheme").play();

 		setTimeout(function(){
 			startup = false;

 		}, 500);

 	}else{
 		newLevel = false;
 		//console.log("newGame111");
 		document.getElementById("level").innerHTML = "Level: " + level;
 	}

 	setTimeout(function(){
 		document.getElementById('mainMenu').style.display = 'none';
 		document.getElementById('mainGame').style.display = 'block';
 		document.getElementById('gameOverScreen').style.display = 'none';
 	}, 200);
 } 

 function firstPlay(){
 	if(alreadyStarted){
 		return;
 	}
 	alreadyStarted = true;
 	document.getElementById("popSound").play();
 	document.getElementById("popSound").pause();
 	var mainTheme = document.getElementById("maintheme");
 	maintheme.volume = .35;
 	maintheme.play();
 	maintheme.loop = true;
 	firstPlayCheck = true;
 	var fadeTarget = document.getElementById("mainMenu");
 	var fadeTarget1 = document.getElementById("play");
 	var fadeTarget2 = document.getElementById("howToPlay");
 	fadeOutEffect1(fadeTarget, -1, -1, 60);
 	fadeOutEffect1(fadeTarget1, -1, -1, 60);
 	fadeOutEffect1(fadeTarget2, -1, -1, 60);
 	setTimeout(changeScreen,800);
 	setTimeout(function(){
 		startup = false;
 		//console.log("firstPlay");
 		score = 0;
 		document.getElementById("score").innerHTML = "Score: " + score;
 	},700);




 }
 function changeScreen(){
 	if(start){
 		//console.log("change1");
 		if(timeLeft == false){
 			timeLeft = true;
 			document.getElementById('gameOverScreen').style.display = 'none';
 		}
 		document.getElementById('mainMenu').style.display = 'none';
 		document.getElementById('mainGame').style.display = 'block';
		//doDebug();
		start = false;
		paused = false;

		doTimer();
	}else{
		//console.log("change2");

		document.getElementById('mainMenu').style.display = 'block';
		document.getElementById('mainGame').style.display = 'none';
		if(timeLeft == false){
			if(chainCount > maxChainCount){
				maxChainCount = chainCount;
			}
			document.getElementById('mainGame').style.display = 'none';
			document.getElementById('mainMenu').style.display = 'none';
			document.getElementById('gameOverScreen').style.display = 'block';

			document.getElementById("gameOverScoreBoard").innerHTML = "You Scored: " + score;
			document.getElementById("gameOverScoreBoard1").innerHTML = "Your Level: " + level;
			document.getElementById("maxChain").innerHTML = "Longest Chain: " + maxChainCount;
			level = 1;
			return;
			
		}

		start = true;
	}
}

function setupBoard(){
	// Build Checkerboard
	var x = 0;
	var y = 0;
	tempButtons = document.getElementsByClassName('hiddenButton');
	cloneButton = tempButtons[0].cloneNode(true);
	//animateSuperBall("superBallSpriteSheet", 720, 720, x , y, 45, 45, 5040, 5040, 40, true, false, false, 0);
	animateSuperBall("superBallSpriteSheet", 240, 240, x , y, 45, 45, 2640, 1200, 40, true, false, false, 0);

	moveBallsToEdge();
	
	//document.getElementById("play").onclick(function(){
		//changeScreen();
	//});

	for(var i = 0; i < 63; i++){
		cloneButton = tempButtons[0].cloneNode(true);
		document.getElementById("hiddenButtons").appendChild(cloneButton);
		//onclick="trackButton(this)"
	}
	tempButtons = document.getElementsByClassName('hiddenButton');
	for(var i = 0; i < tempButtons.length; i++){
		//tempButtons[i].addEventListener("touchstart", trackButton);//ontouchstart = trackButton;
	}

	/*
	for(var i = 0; i < 8; i++){
		for(var j = 0; j < 8; j++){
			if((j + i) % 2 === 0){
				ctx1.fillStyle = 'rgba(128,128,128,.4)';
			}else{
				ctx1.fillStyle = 'rgba(256,256,256,.4)';
			}
			ctx1.fillRect((45*j), (45 * i) , 45, 45);

		}
	}
	ctx.fillStyle = '#FFFFFF';
	*/

	/*
	setTimeout(function(){
		//ctx.clearRect(0,0, c.width, c.height);
		
	}, 400);
	*/
	setTimeout(newGame1, 300);
	

}

function mute1(){
	if(mute){
		mute = false;
		//document.getElementById("mute").style.opacity = 1;
		document.getElementById("mute").querySelector("img").src = "Assets/" + gameType + "/Sound-01.png";
		
		document.activeElement.blur();
		document.getElementById("maintheme").play();
		document.getElementById("maintheme").muted = false;
		document.getElementById("popSound").muted = false;
		
	}else{
		mute = true;
		//document.getElementById("mute").style.opacity = 0.5;
		document.activeElement.blur();
		document.getElementById("mute").querySelector("img").src = "Assets/" + gameType + "/Sound_off-01.png";
		document.getElementById("maintheme").muted = true;
		document.getElementById("popSound").muted = true;
		document.getElementById("maintheme").pause();
	}
}


function pauseGame(){
	if(pausedButtonActive){
		document.getElementById("pauseGameOverlay").style.display = "none";
		//document.getElementById("preventInputGame").style.display = "none";
		document.getElementById("pauseButtonImage").src = "Assets/game8/pause.png"; 
		pausedButtonActive = false;
	}else{
		pausedButtonActive = true;
		document.getElementById("pauseGameOverlay").style.display = "flex";
		document.getElementById("pauseButtonImage").src = "Assets/game8/unpause.png"; 

		selectBalls = [];
		//document.getElementById("preventInputGame").style.display = "block";
		//document.getElementById("pauseButtonText").fontSize = "40pt !important";


		

	}

}
//timeScale = .95;

function rgb2hex2(red, green, blue) {
	var rgb = blue | (green << 8) | (red << 16);
	return '#' + (0x1000000 + rgb).toString(16).slice(1)
}
function doTimer(){
	var greenOffset = (timerColor[1] * timeScale) - 20;
	greenOffset += 80 * (timeScale);

	var redOffset = ( 255 * (1 - timeScale)); 
	redOffset += 50 * (1 - timeScale);

	if(redOffset > 255){
		redOffset = 255;
	}
	if(greenOffset > 255){
		greenOffset = 255;
	}
	if(greenOffset < 0){
		greenOffset = 0;
	}



	if(!changeTimerColor){
		
		var hexColor = rgb2hex2(redOffset, greenOffset,0 );


		//console.log(hexColor);
		document.getElementById("timer").style.backgroundColor = hexColor;
		

		//document.getElementById("timer").style.backgroundColor = 'rgb(' +  redOffset + ',' + greenOffset + ',0) !important;';
	}
	/*
	if(changeTimerColor){
			document.getElementById("timer").style.background = 'white';
			/*
		if(changeColorCounter % 5 === 0){
			document.getElementById("timer").style.background = 'white';
		}else{
			document.getElementById("timer").style.background = 'rgb(' +  redOffset + ',' + greenOffset + ',0)';

		}
		
		changeColorCounter++;
	}else{
		document.getElementById("timer").style.background = 'rgb(' +  redOffset + ',' + greenOffset + ',0)';

	}

	*/

	if(chainCount > maxChainCount){
		maxChainCount = chainCount;
	}
	if(multiMatchAnimating){
		setTimeout(function(){
			doTimer();
		}, 150);
		return;
	}
	if(pausedButtonActive){
		setTimeout(function(){
			doTimer();
		}, 150);
		return;
	}
	if(!paused && timeScale > 0){
		if(timeScale >= 0.99){
			//newLevelReached();
			timeScale = 1;
			timerBrowserHelper();
			setTimeout(function(){
				levelComplete();
			}, 1000);
			return;
		}
		if(timeScale > 0.8){
			if(trophyIndex === 0){
				document.getElementById("trophy").src = "Assets/Trophy6_2.png";
				trophyIndex = 1;
			}
		}else{
			if(trophyIndex === 1){
				document.getElementById("trophy").src = "Assets/Trophy6_1.png";
				trophyIndex = 0;
			}
		}
		timeScale -= 0.0028 + (level * 0.0006);
		if(!constantFlashingTimer && timeScale < 0.2){
			flashTimer();
		}
		if(constantFlashingTimer && timeScale > 0.2){
			constantFlashingTimer = false;
		}
		if(timeScale <= 0){
			timeScale = 0;
			constantFlashingTimer = false;
		}

		timerBrowserHelper();
	}

	if(timeScale < 0.2){
		//document.getElementById("timer").style.background = "linear-gradient(to top, red 50%, orange 99%, green 100%)";
	}
	if(timeScale == 0){//document.getElementById("timer").style.transform == "scaleY(0)"){
		timeLeft = false;
		loseGameAnimation();
		setTimeout(function(){
			changeScreen();
		}, 3000);
	}else{
		setTimeout(function(){
			doTimer();
		}, 150);

	}
}

function timerBrowserHelper(){
	document.getElementById("timer").style.webkitTransform = "translateZ(0)";
	document.getElementById("timer").style.msTransform = "translateZ(0)";
	document.getElementById("timer").style.transform = "translateZ(0)";

	document.getElementById("timer").style.transform = "scale3d(1,"+ timeScale + ",1)";

	document.getElementById("timer").style.webkitTransform = "scale3d(1,"+ timeScale + ",1)";
	//-ms-transform:
	document.getElementById("timer").style.msTransform = "scale3d(1,"+ timeScale + ",1)";
	//document.getElementById("timer").style.transform = "scaleY(" +  timeScale +")";
}

function newLevelReached(){
	/*
	document.getElementById("waitState").style.display = "block";
	document.getElementById("levelUp").style.display = "block";
	document.getElementById("levelCountDown").style.display = "block";
	newLevel = true;
	level++;
	timeScale = 0.6;
	document.getElementById("level").innerHTML = "LEVEL: " + level;
	document.getElementById("timer").style.transform = "scaleY("+ timeScale + ")";
	document.getElementById("levelCountDown").innerHTML = "New Level in 3...";

	setTimeout(function(){
		document.getElementById("levelCountDown").innerHTML = "New Level in 2...";
	}, 1000);
	setTimeout(function(){
		document.getElementById("levelCountDown").innerHTML = "New Level in 1...";
		resetGame();
	}, 2000);
	setTimeout(function(){
		document.getElementById("levelUp").style.display = "none";
		document.getElementById("waitState").style.display = "none";
		document.getElementById("levelCountDown").style.display = "none";
		

		doTimer();
		
	}, 3000);
	*/

	levelComplete();

	setTimeout(function(){
		//console.log("resettting");
		startup = false;
		newLevel = false;
		
	}, 3200);
	return;
}

function startNewLevel(){

	superBallList = [];
	var fadeOutTarget1 = document.getElementById("midLevelScoreboardChain");	
	var fadeOutTarget2 = document.getElementById("midLevelScoreboardTitle");	
	var fadeOutTarget3 = document.getElementById("midLevelScoreboardLevel");	
	var fadeOutTarget4 = document.getElementById("midLevelScoreboardScore");
	var fadeOutTarget5 = document.getElementById("nextLevel");	
	var fadeOutTarget6 = document.getElementById("midLevelScoreboard");	
	var fadeOutTarget7 = document.getElementById("midLevelBackgroundChange");	

	var fadeTarget1 = document.getElementById("timeBox");
	var fadeTarget2 = document.getElementById("leftSideGameBoard");
	var fadeTarget3 = document.getElementById("rightSideGameBoard");
	var fadeTarget4 = document.getElementById("canvasBlock");
	var animateTarget = document.getElementById("canvasBlock");



	fadeOutEffect1(fadeOutTarget1, -1, -1, 50);
	fadeOutEffect1(fadeOutTarget2, -1, -1, 50);
	fadeOutEffect1(fadeOutTarget3, -1, -1, 50);
	fadeOutEffect1(fadeOutTarget4, -1, -1, 50);
	fadeOutEffect1(fadeOutTarget5, -1, -1, 50);
	fadeOutEffect1(fadeOutTarget6, -1, -1, 50);
	//fadeOutEffect1(fadeOutTarget7, -1, -1, 200);


	newLevel = true;
	level++;
	timeScale = 0.6;
	resetGame();
	document.getElementById("level").innerHTML = "Level: " + level;
	document.getElementById("midLevelScoreboard").style.visibility = "hidden";


	setTimeout(function(){
		document.getElementById("canvasBlock").style.transform = 'scaleY(1)';
		document.getElementById("canvasBlock").style.top = '0%';
		//document.getElementById("mainGame").classList.remove("mainGameBackground");
		setTimeout(function(){
		//document.getElementById("midLevelBackgroundChange").style.opacity = 0;
		fadeOutEffect1(fadeOutTarget7, -1, -1, 50);


	}, 50);



		fadeInEffect1(fadeTarget1, -1, -1, 50);
		fadeInEffect1(fadeTarget2, -1, -1, 50);
		fadeInEffect1(fadeTarget3, -1, -1, 50);
		fadeInEffect1(fadeTarget4, -1, -1, 50);

		setTimeout(function(){
			var buttons = document.getElementsByTagName("button");
			for(var buttonIndex = 0; buttonIndex < buttons.length; buttonIndex++){
				var button = buttons[buttonIndex];
				if(button.id != "nextLevel"){
					button.disabled = false;
					button.style.cursor = "pointer";
				}
			}

			//console.log("pausedddd");
			paused = false;
			startup = false;
			newLevel = false;
			doTimer();
		}, 500);
		return;
		setTimeout(function(){
			var scaleY = 100;

			return;
			var expandTarget = setInterval(function () {
				if (scaleY > 0) {
					scaleY+= (100 - scaleY )/5;  
				//console.log("fadingDown " + animateTarget.style.opacity);
			}else{
				clearInterval(expandTarget);
			}
			document.getElementById("canvasBlock").style.transform = 'scaleY(' + ((scaleY / 100) )+ ')';
			document.getElementById("canvasBlock").style.top = 1- (scaleY * 0.5) + '%';
		}, 50);
		}, 200);
	}, 500);

}


function trackButton(event){
	event.preventDefault();
	clusters = [];
	//console.log(document.activeElement);
	if(timeScale <= 0){
		return;
	}
	addToTimerBoolean = true;
	button1 = ballButton; //document.activeElement;
	firstMultiMatch = true;
	multiMatch = false;

	//console.log("ballButton ");
	//console.log(ballButton)
	//console.log("button pressed");
	if(!ballButton){
		button1 = event.target;// document.activeElement;
		button1.focus();
	}else{
		ballButton.focus();
		disableScolling = true;
		//console.log(event);
		//console.log("touch");
		//touchPositions[0] = [event.touches[0].clientX, event.touches[0].clientY ];
		//console.log(touchPositions[0]);

	}
	//console.log(button1);



	//console.log(gridShapes);
	
	
	
	if(waitForSwapBack){
		selectBalls = [];
		waitForSwapBack = false;
	}
	//console.log("caller is " + trackButton.caller);
	var posX;
	var posY;
	//console.log("preTrackButton");
	//console.log(gridShapes);
	for(var i = 0; i < tempButtons.length; i++){
		if(tempButtons[i] == button1){
			posY = Math.floor(i / 8);
			posX = i % 8;
			//console.log('Button clicked at: ' + posX + ', ' + posY);

			var adjacentBall = false;
			if(selectBalls.length === 1){
				var xDifference = Math.abs(selectBalls[0].x1 - posX);
				var yDifference = Math.abs(selectBalls[0].y1 - posY);

				if((xDifference === 1 && yDifference === 0) || (xDifference === 0 && yDifference == 1)){
					adjacentBall = true;
				}
				clicked = true;

				// Reset selectBalls if not adjacent.
				if(!adjacentBall){
					//clearShapes = [gridShapes[posX][posY]];
					clearInterval(pulseHint);
					ctx1.globalAlpha = 1;
					showingHint = false;
					ctx1.clearRect(0,0, c1.width, c1.height);
					if(Object.is(selectBalls[0], gridShapes[posY][posX])){
						selectBalls = [];
						return;
					}
					selectBalls = [gridShapes[posY][posX]];
					ctx1.fillStyle = highlightColor;
					//ctx1.fillRect((45*posX), (45 * posY) , 45, 45);
					ctx1.beginPath();
					ctx1.arc((45 * posX) + 22.5, (45 * posY) + 22.5, 24,0, 2 * Math.PI);
					ctx1.stroke();



					return;
				}
			}
			break;
		}
	}
	ctx1.fillStyle = highlightColor;
	ctx1.strokeStyle = highlightColor;
	//ctx1.fillRect((45*posX), (45 * posY) , 45, 45);

	ctx1.beginPath();
	ctx1.arc((45 * posX) + 22.5, (45 * posY) + 22.5, 24,0, 2 * Math.PI);
	ctx1.stroke();

	//clearShapes.push(gridShapes[posX][posY]);
	if(selectBalls.length < 2){
		//console.log("touch1 " +  posY);
		//console.log("touch2 " +  posX);
		//console.log("touch3 " +  gridShapes[posY][posX]);
		selectBalls.push(gridShapes[posY][posX]);
	}
	showingHint = false;
	//clearShapes.push(new Shape(posX, posY,))
	//console.log(clearShapes);

	if(selectBalls.length === 2){

		chainCount = 0;
		document.getElementById("preventInput").style.display = "block";
		setTimeout(function(){
			document.activeElement.blur();
		},50);
		setTimeout(function(){
			ctx1.clearRect(0,0, c1.width, c1.height);
		},150);

		swapBalls();
	}
}

function passActive(obj) {
	//console.log("active: ");
	//console.log(obj.tagName);
        //trackButton();
        return;
    }

    function makeImages(i){
    	var image1 = new Image();
    	image1.onload = function() {
    		images.push(image1);
    	};

    	image1.src = "Assets/ball" + i + ".png";
    	setTimeout(function(){
    		if(i>=7){
    			return;
    		}
    		makeImages(i + 1);
    	}, 5);

    }
/*
    function animateScript() {
	//document.getElementById("animationCanvas").style.visibility = 'visible';
	console.log("animateScript");
var    position = 0; //start position for the image slicer
var    positionY = 0;
const  interval = 33.3; //100 ms of interval for the setInterval()
const  diff = 720;     //diff as a variable for position offset
var image1 = document.getElementById("sparklesSpriteSheet");// new Image();


tID = setInterval ( () => {
	ctx.drawImage(image1, 0, 0);
	//document.getElementById("spriteTest").style.backgroundPosition = 	`-${position}px ${positionY}px`; 
//we use the ES6 template literal to insert the variable "position"
if (position < 3600)
	{ position = position + diff;}
//we increment the position by 720 each time
else
	{ if(positionY < 5760){
		positionY += diff;
		position = 0; 
	}else{
		positionY = 0;
	}
}
//reset the position to 256px, once position exceeds 1536px
}
, interval); //end of setInterval
} //end of animateScript()
*/
function newGame1(){


	timeLeft = true;
	for(var y = 0; y < 8; y++){
		for(var x = 0; x < 8; x++){
			var rand = Math.floor((Math.random() * 5));
			var image1 = document.getElementById("ball" + rand);// new Image();

			ctx.drawImage(image1, (45*x), (45 * y), 45, 45);
			var temp = new Shape(45*x, 45*y, x, y, rand, 0);
			//allShapes.push(temp);
			gridShapes[y][x]= temp;
		}
	}

	for(var y = 0; y < 8; y++){
		for(var x = 0; x < 8; x++){
			var xRight = true;
			var xLeft = true;
			var yUp = true;
			var yDown = true;

			var xRightCount = 1;
			var xLeftCount = 1;
			var upCount = 1;
			var downCount = 1;
			var imageCheck = gridShapes[y][x].image;
			for(var index = 0; index < 8; index++){
				if(xLeft && x - index > -1){
					if(imageCheck === gridShapes[y][x - index].image){
						xLeftCount++;
					}else{
						xLeft = false;
					}	
					if(xLeftCount > 2){
						xLeft = false;
						while(imageCheck === gridShapes[y][x - index].image){
							gridShapes[y][x - index].image = Math.floor((Math.random() * 5));
						}
					}
				}

				if(xRight && x + index < 8){
					if(imageCheck === gridShapes[y][x + index].image){
						xRightCount++;
					}else{
						xRight = false;
					}	
					if(xRightCount > 2){
						xRight = false;
						while(imageCheck === gridShapes[y][x + index].image){
							gridShapes[y][x + index].image = Math.floor((Math.random() * 5));
						}
					}
				}

				if(yUp && y - index > -1){
					if(imageCheck === gridShapes[y - index][x].image){
						upCount++;
					}else{
						yUp = false;
					}	
					if(upCount > 2){
						yUp = false;
						while(imageCheck === gridShapes[y - index][x].image){
							gridShapes[y - index][x].image = Math.floor((Math.random() * 5));
						}
					}
				}

				if(yDown && y + index < 8){
					if(imageCheck === gridShapes[y+ index][x].image){
						downCount++;
					}else{
						yDown = false;
					}	
					if(downCount > 2){
						yDown = false;
						while(imageCheck === gridShapes[y + index][x].image){
							gridShapes[y + index][x].image = Math.floor((Math.random() * 5));
						}
					}
				}


			}
			/*
			var rand = Math.floor((Math.random() * 5));
			var image1 = document.getElementById("ball" + rand);// new Image();

			ctx.drawImage(image1, (45*x), (45 * y));
			var temp = new Shape(45*x, 45*y, x, y, rand);
			//allShapes.push(temp);
			gridShapes[y][x]= temp;

			*/
			findClusters();
			removeClusters();
			massMoveBalls3();
			requestAnimationFrame(restoreBoard);
			//console.log("actual newGame1 " + startup);
			if(!newLevel){
				score = 0;
				chainCount = 0;
				maxChainCount = 0;
			}else{
				
				chainCount = 0;
			}

		}
	}
	//return;
}
/*
function doDebug(){
	if(clicked){

		return;
	}
	console.log("doDebug");
	console.log(gridShapes);
	setTimeout(function(){
		doDebug();}, 100);
}
*/


/*async*/function restoreBoard(){
	superBallList = [];
	if(printOnce1){
		printOnce1 = false;
				//console.log("printOnce1");
				//console.log(gridShapes);
			}
			ctx.clearRect(0,0, c.width, c.height);
			//for(var i = 0; i < allShapes.length; i++){
				for(var i = 0; i < gridShapes.length; i++){
					for(var j = 0; j < gridShapes[i].length; j++){
				//console.log(allShapes[i].x);
				//var image1 = new Image();
				if(!gridShapes[i][j]){
					continue;
				}
				var x = gridShapes[i][j].x;//allShapes[i].x;
				var y = gridShapes[i][j].y;//allShapes[i].y;
				var tempImage = gridShapes[i][j].image;//allShapes[i].image;
				
				if(tempImage === 5){
					superBallList.push(gridShapes[i][j]);
				}
				if(tempImage === -1 || tempImage === 5){
					//console.log("nope");
					continue;
				}

				var image1 = document.getElementById("ball" + tempImage);
				ctx.drawImage(image1, x, y, 45, 45);

			}
		}

		if(toMove){
			//window.requestAnimationFrame(massMoveBalls);
			//await massMoveBalls();
		}
		//restoreBoard();


	}

	function refreshScreen(){
		//console.log("clearing");
		clearTrack = 0;
		ctx.clearRect(0,0, c.width, c.height);
		window.requestAnimationFrame(restoreBoard);

	}

	function addToTimer(){
		if(!timeLeft){
			return;
		}
		var timeScaleTemp = 0.10 + (level * 0.02);
		if(timeScaleTemp > 0.12){
			timeScaleTemp = 0.12;
		}
		if(multiMatch){
			if(firstMultiMatch){
				timeScale += timeScaleTemp;	
				firstMultiMatch = false;
				//console.log("addToTimer0");
			}else{
				timeScale += timeScaleTemp / 4;	
				//console.log("addToTimer1");

			}
		}else{
			timeScale += timeScaleTemp;
			//console.log("addToTimer2");

		}

		if(timeScale > 1){
			timeScale = 1;
		}
		timerBrowserHelper();
	}


/*
	function superBallPop(superBallTemp){
		console.log("popppp");
		superBallClusters = [];
		var tempClusters = [];
		var ballsFound = [];
		tempClusters.push({ column: superBallTemp.x1, row: superBallTemp.y1 - 1,
			length: 0, horizontal: true });
		tempClusters.push({ column: superBallTemp.x1, row: superBallTemp.y1,
			length: 0, horizontal: true });
		tempClusters.push({ column: superBallTemp.x1, row: superBallTemp.y1 + 1,
			length: 0, horizontal: true });


		superBallClusters.push({ column: superBallTemp.x1, row: superBallTemp.y1,
			length: 1, horizontal: true });

		ballsFound.push(superBallTemp);

		if(superBallTemp.x1 - 1 > -1){
			superBallClusters.push({ column: superBallTemp.x1 - 1, row: superBallTemp.y1,
				length: 1, horizontal: true });
			tempClusters[1].length++;
			tempClusters[1].column--;
			gridShapes[superBallTemp.y1][superBallTemp.x1 - 1].image = -1;
			ballsFound.push(gridShapes[superBallTemp.y1][superBallTemp.x1 - 1]);
			if(superBallTemp.y1 - 1 > -1){
				superBallClusters.push({ column: superBallTemp.x1 - 1, row: superBallTemp.y1 - 1,
					length: 1, horizontal: true });
				tempClusters[0].length++;
				tempClusters[0].column--;
				gridShapes[superBallTemp.y1 - 1][superBallTemp.x1 - 1].image = -1;
				ballsFound.push(gridShapes[superBallTemp.y1 - 1][superBallTemp.x1 - 1]);

			}		
			if(superBallTemp.y1 + 1 < 8){
				superBallClusters.push({ column: superBallTemp.x1 - 1, row: superBallTemp.y1 + 1,
					length: 1, horizontal: true });
				tempClusters[2].length++;
				tempClusters[2].column--;
				ballsFound.push(gridShapes[superBallTemp.y1 + 1][superBallTemp.x1 - 1]);
				gridShapes[superBallTemp.y1 + 1][superBallTemp.x1 - 1].image = -1;

			}
		}
		if(superBallTemp.x1 + 1 < 8){
			superBallClusters.push({ column: superBallTemp.x1 + 1, row: superBallTemp.y1,
				length: 1, horizontal: true });
			tempClusters[1].length++;
			gridShapes[superBallTemp.y1][superBallTemp.x1 + 1].image = -1;
			ballsFound.push(gridShapes[superBallTemp.y1][superBallTemp.x1 + 1]);

			//tempClusters[1].column--;

			if(superBallTemp.y1 - 1 > -1){
				superBallClusters.push({ column: superBallTemp.x1 + 1, row: superBallTemp.y1 - 1,
					length: 1, horizontal: true });
				tempClusters[0].length++;
				gridShapes[superBallTemp.y1 - 1][superBallTemp.x1 + 1].image = -1;
				ballsFound.push(gridShapes[superBallTemp.y1 - 1][superBallTemp.x1 + 1]);

			}		
			if(superBallTemp.y1 + 1 < 8){
				superBallClusters.push({ column: superBallTemp.x1 + 1, row: superBallTemp.y1 + 1,
					length: 1, horizontal: true });
				tempClusters[2].length++;
				gridShapes[superBallTemp.y1 + 1][superBallTemp.x1 + 1].image = -1;
				ballsFound.push(gridShapes[superBallTemp.y1 + 1][superBallTemp.x1 + 1]);

			}
		}
		if(superBallTemp.y1 - 1 > -1){
			superBallClusters.push({ column: superBallTemp.x1, row: superBallTemp.y1 - 1,
				length: 1, horizontal: true });
			tempClusters[0].length++;
			gridShapes[superBallTemp.y1 - 1][superBallTemp.x1].image = -1;
			ballsFound.push(gridShapes[superBallTemp.y1 - 1][superBallTemp.x1]);

		}
		if(superBallTemp.y1 + 1 < 8){
			superBallClusters.push({ column: superBallTemp.x1, row: superBallTemp.y1 + 1,
				length: 1, horizontal: true });
			tempClusters[2].length++;
			gridShapes[superBallTemp.y1 + 1][superBallTemp.x1].image = -1;
			ballsFound.push(gridShapes[superBallTemp.y1 + 1][superBallTemp.x1]);

		}
		superBallPopAnimation = true;
		clusters = tempClusters;
		//superBallList

		for(var ballsFoundCount = 0; ballsFoundCount < ballsFound.length; ballsFoundCount++){
			for(superBallListCount = 0; superBallListCount < superBallList.length; superBallListCount++){
				if(Object.is(superBallList[superBallListCount], ballsFound[ballsFoundCount])){
					console.log(superBallList);
					gridShapes[superBallList[superBallListCount].y1][superBallList[superBallListCount].x1].image = Math.floor((Math.random() * 5));
					superBallList.splice(superBallListCount, 1);
					console.log("spliced");
					//console.log(superBallList);

				}
			}
		}
		/*
		for(superBallListCount = 0; superBallListCount < superBallList.length; superBallListCount++){
			if(Object.is(superBallList[superBallListCount], superBallTemp)){
				console.log(superBallList);
				superBallList.splice(superBallListCount, 1);
				console.log("spliced");
				console.log(superBallList);

			}
		}
		
		console.log(clusters);
		highlightMatchSuperBall(superBallTemp);
		//removeClusters();
	}	

	*/
	function superBallPop(superBallTemp){
		//console.log("popppp");
		superBallClusters = [];
		var tempClusters = [];
		var ballsFound = [];
		
		tempClusters[1] = { column: superBallTemp.x1, row: superBallTemp.y1,
			length: 1, horizontal: false };



			superBallClusters.push({ column: superBallTemp.x1, row: superBallTemp.y1,
				length: 1, horizontal: false });

			ballsFound.push(superBallTemp);

			if(superBallTemp.x1 - 1 > -1){
				tempClusters[0] = { column: superBallTemp.x1 - 1, row: superBallTemp.y1,
					length: 0, horizontal: false };


					superBallClusters.push({ column: superBallTemp.x1 - 1, row: superBallTemp.y1,
						length: 1, horizontal: true });
					tempClusters[0].length++;
			//tempClusters[1].column--;
			//todoMain
			//gridShapes[superBallTemp.y1][superBallTemp.x1 - 1].image = -1;
			ballsFound.push(gridShapes[superBallTemp.y1][superBallTemp.x1 - 1]);
			if(superBallTemp.y1 - 1 > -1){
				superBallClusters.push({ column: superBallTemp.x1 - 1, row: superBallTemp.y1 - 1,
					length: 1, horizontal: true });
				tempClusters[0].length++;
				tempClusters[0].row--;
				//gridShapes[superBallTemp.y1 - 1][superBallTemp.x1 - 1].image = -1;
				ballsFound.push(gridShapes[superBallTemp.y1 - 1][superBallTemp.x1 - 1]);

			}		
			if(superBallTemp.y1 + 1 < 8){
				superBallClusters.push({ column: superBallTemp.x1 - 1, row: superBallTemp.y1 + 1,
					length: 1, horizontal: true });
				tempClusters[0].length++;
				//tempClusters[0].column--;
				ballsFound.push(gridShapes[superBallTemp.y1 + 1][superBallTemp.x1 - 1]);
				//gridShapes[superBallTemp.y1 + 1][superBallTemp.x1 - 1].image = -1;

			}
		}
		if(superBallTemp.x1 + 1 < 8){
			tempClusters[2] = { column: superBallTemp.x1 + 1, row: superBallTemp.y1,
				length: 0, horizontal: false };

				superBallClusters.push({ column: superBallTemp.x1 + 1, row: superBallTemp.y1,
					length: 1, horizontal: true });
				tempClusters[2].length++;
			//gridShapes[superBallTemp.y1][superBallTemp.x1 + 1].image = -1;
			ballsFound.push(gridShapes[superBallTemp.y1][superBallTemp.x1 + 1]);

			//tempClusters[1].column--;

			if(superBallTemp.y1 - 1 > -1){
				superBallClusters.push({ column: superBallTemp.x1 + 1, row: superBallTemp.y1 - 1,
					length: 1, horizontal: true });
				tempClusters[2].length++;
				tempClusters[2].row--;
				//gridShapes[superBallTemp.y1 - 1][superBallTemp.x1 + 1].image = -1;
				ballsFound.push(gridShapes[superBallTemp.y1 - 1][superBallTemp.x1 + 1]);

			}		
			if(superBallTemp.y1 + 1 < 8){
				superBallClusters.push({ column: superBallTemp.x1 + 1, row: superBallTemp.y1 + 1,
					length: 1, horizontal: true });
				tempClusters[2].length++;
				//gridShapes[superBallTemp.y1 + 1][superBallTemp.x1 + 1].image = -1;
				ballsFound.push(gridShapes[superBallTemp.y1 + 1][superBallTemp.x1 + 1]);

			}
		}
		if(superBallTemp.y1 - 1 > -1){
			superBallClusters.push({ column: superBallTemp.x1, row: superBallTemp.y1 - 1,
				length: 1, horizontal: true });
			tempClusters[1].length++;
			tempClusters[1].row--;
			//gridShapes[superBallTemp.y1 - 1][superBallTemp.x1].image = -1;
			ballsFound.push(gridShapes[superBallTemp.y1 - 1][superBallTemp.x1]);

		}
		if(superBallTemp.y1 + 1 < 8){
			superBallClusters.push({ column: superBallTemp.x1, row: superBallTemp.y1 + 1,
				length: 1, horizontal: true });
			tempClusters[1].length++;
			//gridShapes[superBallTemp.y1 + 1][superBallTemp.x1].image = -1;
			ballsFound.push(gridShapes[superBallTemp.y1 + 1][superBallTemp.x1]);

		}
		//console.log("splice1");
		//console.log(tempClusters);
		/*
		if(tempClusters[2].length === 0){
			tempClusters.splice(2, 1);
		}
		console.log(tempClusters);
		if(tempClusters[0].length === 0){
			tempClusters.splice(0, 1);
		}
		console.log(tempClusters);
		*/
		superBallPopAnimation = true;
		clusters = tempClusters;
		//superBallList
		//console.log("clusterListing");
		//console.log(ballsFound);
		//console.log(clusters);
		for(var ballsFoundCount = 0; ballsFoundCount < ballsFound.length; ballsFoundCount++){
			for(superBallListCount = 0; superBallListCount < superBallList.length; superBallListCount++){
				if(Object.is(superBallList[superBallListCount], ballsFound[ballsFoundCount])){
					//console.log(superBallList);
					gridShapes[superBallList[superBallListCount].y1][superBallList[superBallListCount].x1].image = Math.floor((Math.random() * 5));
					superBallList.splice(superBallListCount, 1);
					//console.log("spliced");
					//console.log(superBallList);

				}
			}
		}
		/*
		for(superBallListCount = 0; superBallListCount < superBallList.length; superBallListCount++){
			if(Object.is(superBallList[superBallListCount], superBallTemp)){
				console.log(superBallList);
				superBallList.splice(superBallListCount, 1);
				console.log("spliced");
				console.log(superBallList);

			}
		}
		*/
		//console.log(clusters);
		requestAnimationFrame(function(){
			highlightMatchSuperBall(superBallTemp);
		});
		//removeClusters();
	}	

	/*
		function superBallPop(superBallTemp){
		console.log("popppp");
		superBallClusters.push({ column: superBallTemp.x1, row: superBallTemp.y1,
			length: 1, horizontal: true });
		if(superBallTemp.x1 - 1 > -1){
			superBallClusters.push({ column: superBallTemp.x1 - 1, row: superBallTemp.y1,
				length: 1, horizontal: true });
			if(superBallTemp.y1 - 1 > -1){
				superBallClusters.push({ column: superBallTemp.x1 - 1, row: superBallTemp.y1 - 1,
					length: 1, horizontal: true });
			}		
			if(superBallTemp.y1 + 1 < 8){
				superBallClusters.push({ column: superBallTemp.x1 - 1, row: superBallTemp.y1 + 1,
					length: 1, horizontal: true });
			}
		}
		if(superBallTemp.x1 + 1 < 8){
			superBallClusters.push({ column: superBallTemp.x1 + 1, row: superBallTemp.y1,
				length: 1, horizontal: true });
			if(superBallTemp.y1 - 1 > -1){
				superBallClusters.push({ column: superBallTemp.x1 + 1, row: superBallTemp.y1 - 1,
					length: 1, horizontal: true });
			}		
			if(superBallTemp.y1 + 1 < 8){
				superBallClusters.push({ column: superBallTemp.x1 + 1, row: superBallTemp.y1 + 1,
					length: 1, horizontal: true });
			}
		}
		if(superBallTemp.y1 - 1 > -1){
			superBallClusters.push({ column: superBallTemp.x1, row: superBallTemp.y1 - 1,
				length: 1, horizontal: true });
		}
		if(superBallTemp.y1 + 1 < 8){
			superBallClusters.push({ column: superBallTemp.x1, row: superBallTemp.y1 + 1,
				length: 1, horizontal: true });
		}
		superBallPopAnimation = true;
		highlightMatchSuperBall(superBallTemp);
		//removeClusters();
	}	
	*/

	function swapBalls(){
		//console.log("swapBalls");
		canClick = false;
		destination1 = [selectBalls[0].x, selectBalls[0].y];
		destination2 = [selectBalls[1].x, selectBalls[1].y];
		doSwap(destination1, destination2);
	}

	/*async*/ function doSwap(dest1, dest2){ 
		/*
		if(dest1[0] === selectBalls[1].x){
		//return;
	}
	*/

		const SWAP_SPEED = 1.5; // Pixels per frame
		if(timeScale <= 0){
			return;
		}
		var animateBallSwap = function () {// Second ball selected moves first
			if(selectBalls[1].x < dest1[0]){
				//console.log("math0");
				selectBalls[1].x += SWAP_SPEED;
			}else if(selectBalls[1].x > dest1[0]){
				//console.log("math1");
				selectBalls[1].x -= SWAP_SPEED;
			}else if(selectBalls[1].y < dest1[1]){
				//console.log("math2");
				selectBalls[1].y += SWAP_SPEED;
			}else if(selectBalls[1].y > dest1[1]){
				//console.log("math3");
				selectBalls[1].y -= SWAP_SPEED;
			}

			// First ball selected moves next
			if(selectBalls[0].x < dest2[0]){
				selectBalls[0].x += SWAP_SPEED;
			}else if(selectBalls[0].x > dest2[0]){
				selectBalls[0].x -= SWAP_SPEED;
			}else if(selectBalls[0].y < dest2[1]){
				selectBalls[0].y += SWAP_SPEED;
			}else if(selectBalls[0].y > dest2[1]){
				selectBalls[0].y -= SWAP_SPEED;
			}

			// Redraw the board.
			window.requestAnimationFrame(restoreBoard);
			
			if ((dest1[0] !== selectBalls[1].x) || (dest1[1] !== selectBalls[1].y)) {
				requestAnimationFrame(animateBallSwap);
			}else{
				clearShapes = [];

	// Swap the grid positions in the ball objects.
	//console.log("doSwap4");
	/*
	for(var superBallCount = 0; superBallCount < superBallList.length; superBallCount++){
		if(Object.is(superBallList[superBallCount], selectBalls[0])){
			/*
				var ball1X = ball1.x1,
	ball1Y = ball1.y1,
	ball2X = ball2.x1,
	ball2Y = ball2.y1;
	//console.log("swapBallsinGrid");
	//console.log(gridShapes);
	gridShapes[ball1Y][ball1X] = ball2;
	gridShapes[ball2Y][ball2X] = ball1;
	
			var ball1 = gridShapes[selectBalls[0].y1][selectBalls[0].x1];
			var ball2 = gridShapes[selectBalls[1].y1][selectBalls[1].x1];
			console.log("cancelSwap1");
			console.log(gridShapes);
			gridShapes[selectBalls[0].y1][selectBalls[0].x1] = ball2;
			gridShapes[selectBalls[1].y1][selectBalls[1].x1] = ball1;
			console.log(gridShapes);


			superBallPop(superBallList[superBallCount]);
			return;
		}
		if(Object.is(superBallList[superBallCount], selectBalls[1])){
			/*
						var ball1 = gridShapes[selectBalls[0].y1][selectBalls[0].x1];
			var ball2 = gridShapes[selectBalls[1].y1][selectBalls[1].x1];
						console.log("cancelSwap2");
			console.log(gridShapes);
			gridShapes[selectBalls[0].y1][selectBalls[0].x1] = ball2;
			gridShapes[selectBalls[1].y1][selectBalls[1].x1] = ball1;
			console.log(gridShapes);
			
			superBallPop(superBallList[superBallCount]);

			return;
		}
	}
	*/
	//console.log("matchMade");
	var matchMade = swapBallsInGrid(selectBalls[0], selectBalls[1], true);
	if(selectBalls[0].image === 5){
		superBallPop(selectBalls[0]);
		return;
	}
	if(selectBalls[1].image === 5){
		superBallPop(selectBalls[1]);
		return;
	}

	//console.log("doSwap5");
	//var matchMade = checkMatches();
	if(!matchMade){
		// Swap them back.
		swapBallsInGrid(selectBalls[0], selectBalls[1], false);

		requestAnimationFrame(animateBallSwapBack);
		
	}else{

		ctx1.fillStyle = highlightColor;
		ctx1.strokeStyle = highlightColor;

	//ctx1.fillRect((45*posX), (45 * posY) , 45, 45);
		/*
        clusters.push({ column: column+1-matchlength, row:row,
    	length: matchlength, horizontal: true });
    	*/

    	//ctx1.beginPath();
    	//ctx1.arc((45 * posX) + 22.5, (45 * posY) + 22.5, 24,0, 2 * Math.PI);
    	//ctx1.fill();

    	//tempfiller
    	//for(var highlightSize = 1; highlightSize < 25; highlightSize++)

/*
    		   		var highlightMatch = function(){
    		for(var clusterCount = 0; clusterCount < clusters.length; clusterCount++){
    			for(var clusterLength = 0; clusterLength < clusters[clusterCount].length; clusterLength++){


    				if(clusters[clusterCount].horizontal){
    					console.log(clusters[clusterCount].matchlength + 99);
    					//ctx.fillStyle = 'rgba(255,215,0,' + (0 + (highlightSize * 2))/100 + ' )';
    					var grd=ctx.createRadialGradient(5,5,5,90,60,100);
						grd.addColorStop(0,"yellow");
						grd.addColorStop(1,"white");
						ctx.fillStyle = grd;
    			//ctx1.fillRect((45 * clusters[clusterCount].column) + 15, (45 * clusters[clusterCount].row) - 3 , (45 * clusters[clusterCount].length) - 30, 50);
    			ctx.beginPath();
    			ctx.arc((45 * (clusters[clusterCount].column + clusterLength)) + 22.5, (45 * clusters[clusterCount].row) + 22.5, highlightSize/2,0, 2 * Math.PI);
    			ctx.fill();


    		}
    	}
    }
    if(highlightSize === 50){
    	return;
    }
    setTimeout(function(){
    	highlightSize++;
    	window.requestAnimationFrame(restoreBoard);
    requestAnimationFrame(highlightMatch);
}, 10);
}
*/




requestAnimationFrame(highlightMatch);
ctx.globalAlpha = 1;
ctx1.clearRect(0,0, c1.width, c1.height);
setTimeout(function(){
	//ctx.globalAlpha = 1;
	//ctx1.clearRect(0,0, c1.width, c1.height);
	//ctx2.clearRect(0,0, c2.width, c2.height);
	removeClusters();
	//addToTimer();

	//canClick = true;

}, 600);



}
}
};

if(timeScale <= 0){
	return;
}

var animateBallSwapBack = function () {
	if ((dest2[0] !== selectBalls[1].x) || (dest2[1] !== selectBalls[1].y)) {
		requestAnimationFrame(animateBallSwapBack);
	}else{
		canClick = true;
		selectBalls = [];
		setTimeout(function(){
			document.getElementById("preventInput").style.display = "none";
		}, 200);
		return;
				//requestAnimationFrame(doneSwappingAction);
			}
			// Second ball selected moves first
			if(selectBalls[1].x < dest2[0]){
				//console.log("math0");
				selectBalls[1].x += SWAP_SPEED;
			}else if(selectBalls[1].x > dest2[0]){
				//console.log("math1");
				selectBalls[1].x -= SWAP_SPEED;
			}else if(selectBalls[1].y < dest2[1]){
				//console.log("math2");
				selectBalls[1].y += SWAP_SPEED;
			}else if(selectBalls[1].y > dest2[1]){
				//console.log("math3");
				selectBalls[1].y -= SWAP_SPEED;
			}

			// First ball selected moves next
			if(selectBalls[0].x < dest1[0]){
				selectBalls[0].x += SWAP_SPEED;
			}else if(selectBalls[0].x > dest1[0]){
				selectBalls[0].x -= SWAP_SPEED;
			}else if(selectBalls[0].y < dest1[1]){
				selectBalls[0].y += SWAP_SPEED;
			}else if(selectBalls[0].y > dest1[1]){
				selectBalls[0].y -= SWAP_SPEED;
			}

			// Redraw the board.
			window.requestAnimationFrame(restoreBoard);
		};

		var doneSwappingAction = function(){
			clearShapes = [];
			//console.log("done first swap");

				// Swap the grid positions in the ball objects.
				//console.log("doSwap4");
				var matchMade = swapBallsInGrid(selectBalls[0], selectBalls[1], true);
				//console.log("doSwap5");
				//var matchMade = checkMatches();
				if(!matchMade){
					// Swap them back.
					swapBallsInGrid(selectBalls[0], selectBalls[1], false);

						// Redraw the board.
						window.requestAnimationFrame(restoreBoard);
						if(!waitForSwapBack){
							waitForSwapBack = true;

						}

						canClick = true;
						setTimeout(function(){
							document.getElementById("preventInput").style.display = "none";
						}, 200);
					}else{
						removeClusters();
						//addToTimer();
						canClick = true;

					}
				};
				requestAnimationFrame(animateBallSwap);
				return;

	//if((dest1[0] == selectBalls[1].x) && (dest1[1] == selectBalls[1].y) && (dest2[0] == selectBalls[0].x) && (dest2[1] == selectBalls[0].y)){

		//console.log("done");
		clearShapes = [];
		//console.log("done first swap");

	// Swap the grid positions in the ball objects.
	//console.log("doSwap4");
	var matchMade = swapBallsInGrid(selectBalls[0], selectBalls[1], true);
	//console.log("doSwap5");
	//var matchMade = checkMatches();
	if(!matchMade){
		// Swap them back.
		swapBallsInGrid(selectBalls[0], selectBalls[1], false);

		while ((dest2[0] !== selectBalls[1].x) || (dest2[1] !== selectBalls[1].y)) {
			// Second ball selected moves first
			if(selectBalls[1].x < dest2[0]){
				//console.log("math0");
				selectBalls[1].x += SWAP_SPEED;
			}else if(selectBalls[1].x > dest2[0]){
				//console.log("math1");
				selectBalls[1].x -= SWAP_SPEED;
			}else if(selectBalls[1].y < dest2[1]){
				//console.log("math2");
				selectBalls[1].y += SWAP_SPEED;
			}else if(selectBalls[1].y > dest2[1]){
				//console.log("math3");
				selectBalls[1].y -= SWAP_SPEED;
			}

			// First ball selected moves next
			if(selectBalls[0].x < dest1[0]){
				selectBalls[0].x += SWAP_SPEED;
			}else if(selectBalls[0].x > dest1[0]){
				selectBalls[0].x -= SWAP_SPEED;
			}else if(selectBalls[0].y < dest1[1]){
				selectBalls[0].y += SWAP_SPEED;
			}else if(selectBalls[0].y > dest1[1]){
				selectBalls[0].y -= SWAP_SPEED;
			}

			// Redraw the board.
			window.requestAnimationFrame(restoreBoard);
			if(!waitForSwapBack){
				waitForSwapBack = true;

			}

			// Suspend until the next animation frame.
			await(promiseRAF());
		}
		canClick = true;
		setTimeout(function(){
			document.getElementById("preventInput").style.display = "none";
		}, 200);
	}else{
		//console.log("beginRemoveClusters");
		removeClusters();
		//addToTimer();
		canClick = true;

	}
}
function highlightMatch(){
	var screenCleared = false;
	ctx2.clearRect(0,0, c2.width, c2.height);
	//console.log("highlightSize " + highlightSize);
	//console.log(clusters);
	var foundSuperBallPop = false;
	paused = true;
	//console.log("yelp");
	//console.log("highlighting");

	for(var clusterCount = 0; clusterCount < clusters.length; clusterCount++){
		for(var clusterLength = 0; clusterLength < clusters[clusterCount].length; clusterLength++){
			

			//console.log("matchlength " + clusters[clusterCount].length);
			//console.log(selectBalls);
			if(clusters[clusterCount].horizontal){
				if(clusters[clusterCount].length > 3){
					if(superBallHold === null){
						if(Object.is(gridShapes[clusters[clusterCount].row][clusters[clusterCount].column + clusterLength], selectBalls[0])){
							//superBallHold = gridShapes[clusters[clusterCount].row][clusters[clusterCount].column + clusterLength];
							superBallHold = gridShapes[selectBalls[0].y1][selectBalls[0].x1];

							//toMakeSuperBall.push(clusterCount);
							//superBallListIndex = [];
							//superBallClusterIndex = [];
							superBallHold.image = 5;
							superBallList.push(superBallHold);
							//console.log("hit1");
							continue;
						}else{
							if(Object.is(gridShapes[clusters[clusterCount].row][clusters[clusterCount].column + clusterLength], selectBalls[1])){
								//superBallHold = gridShapes[clusters[clusterCount].row][clusters[clusterCount].column + clusterLength];
								superBallHold = gridShapes[selectBalls[1].y1][selectBalls[1].x1];

								//toMakeSuperBall.push(clusterCount);
								superBallHold.image = 5;
								superBallList.push(superBallHold);
								//console.log("hit2");
								continue;
							}
						}
					}else{
						if(superBallHold1 === null){
							if(false){//superBallList.includes(gridShapes[clusters[clusterCount].row  + clusterLength][clusters[clusterCount].column])){

							}else{
								if(Object.is(gridShapes[clusters[clusterCount].row][clusters[clusterCount].column + clusterLength], selectBalls[0])){
									superBallHold1 = gridShapes[clusters[clusterCount].row][clusters[clusterCount].column + clusterLength];
							//toMakeSuperBall.push(clusterCount);
							//superBallListIndex = [];
							//superBallClusterIndex = [];
							superBallHold1.image = 5;
							superBallList.push(superBallHold1);
							//console.log("hit1");
							continue;
						}else{
							if(Object.is(gridShapes[clusters[clusterCount].row][clusters[clusterCount].column + clusterLength], selectBalls[1])){
								superBallHold1 = gridShapes[clusters[clusterCount].row][clusters[clusterCount].column + clusterLength];
								//toMakeSuperBall.push(clusterCount);
								superBallHold1.image = 5;
								superBallList.push(superBallHold1);
								//console.log("hit2");
								continue;
							}
						}
					}
				}
				if(Object.is(gridShapes[clusters[clusterCount].row][clusters[clusterCount].column + clusterLength], superBallHold)){
							//console.log("hit0");
							continue;
						}
						if(Object.is(gridShapes[clusters[clusterCount].row][clusters[clusterCount].column + clusterLength], superBallHold1)){
							//console.log("hit0");
							continue;
						}
					}
				}
				//ctx.clearRect(x,y, 45 *(clusters[clusterCount].length - 1), 45);

				if(!screenCleared){
					//ctx.clearRect(x,y, (45 * clusters[clusterCount].length), 45);
					screenCleared = true;
				}
				var x = 45 * (clusters[clusterCount].column + clusterLength);//allShapes[i].x;
				var y = 45 * clusters[clusterCount].row;//allShapes[i].y;
				ctx.clearRect(x,y, 45 , 45);

				//superBallExplosion

				if(false){

					//console.log(clusters);
					if(animateThreads >=9){
						continue;
					}
					animateThreads++;
					//console.log("animateCheck");
					//console.log("x " + x);
					//console.log("y " + y);
					//console.log("cluster " + clusters[clusterCount]);

					//var temp2 = animateScript("ballExplosion", 720, 720, x , y, 45, 45, 3600, 5760, 33.3, true, true);
					continue;




				}

				var tempImage = gridShapes[clusters[clusterCount].row][clusters[clusterCount].column + clusterLength].image;//allShapes[i].image;
				if(highlightSize > 50){
					ctx2.globalAlpha = (100 - opacityShift)/100;
				}
				var image1 = document.getElementById("ball" + tempImage);
				ctx2.drawImage(image1, x - (highlightSize/4), y - (highlightSize/4), 45 + (highlightSize/2), 45 + (highlightSize/2));
				//console.log("best highlight1111");
				ctx2.fillStyle = 'rgba(255,243,179,' + (0 + (highlightSize * 2))/100 + ' )';
    			//ctx1.fillRect((45 * clusters[clusterCount].column) + 15, (45 * clusters[clusterCount].row) - 3 , (45 * clusters[clusterCount].length) - 30, 50);
    			ctx2.beginPath();
    			ctx2.arc((45 * (clusters[clusterCount].column + clusterLength)) + 22.5 , (45 * clusters[clusterCount].row) + 22.5 , 22.5 + (highlightSize/4),0, 2 * Math.PI);
    			ctx2.fill();
    		}


    		if(!clusters[clusterCount].horizontal){

    			//ctx.clearRect(x,y, 45, 45  * (clusters[clusterCount].length - 1));
    			if(clusters[clusterCount].length > 3){
    				if(superBallHold === null){
    					if(Object.is(gridShapes[clusters[clusterCount].row  + clusterLength][clusters[clusterCount].column], selectBalls[0])){
    						superBallHold = gridShapes[clusters[clusterCount].row  + clusterLength][clusters[clusterCount].column];
    						//toMakeSuperBall.push([clusterCount, superBallList.length);
    						superBallListIndex.push(superBallList.length);
    						superBallClusterIndex.push(clusterCount);
    						superBallHold.image = 5;
    						superBallList.push(superBallHold);
    						//console.log("hit1");
    						//console.log(superBallHold);
    						continue;
    					}else{
    						if(Object.is(gridShapes[clusters[clusterCount].row + clusterLength][clusters[clusterCount].column], selectBalls[1])){
    							superBallHold = gridShapes[clusters[clusterCount].row + clusterLength][clusters[clusterCount].column];
    							//toMakeSuperBall.push([clusterCount, superBallList.length);
    							superBallListIndex.push(superBallList.length);
    							superBallClusterIndex.push(clusterCount);
    							superBallHold.image = 5;
    							superBallList.push(superBallHold);
    							//console.log("hit2");
    							//console.log(superBallHold);

    							continue;
    						}
    					}
    				}else{
    					if(superBallHold1 === null){
    						if(superBallList.includes(gridShapes[clusters[clusterCount].row  + clusterLength][clusters[clusterCount].column])){

    						}else{
    							if(Object.is(gridShapes[clusters[clusterCount].row  + clusterLength][clusters[clusterCount].column], selectBalls[0])){
    								superBallHold1 = gridShapes[clusters[clusterCount].row  + clusterLength][clusters[clusterCount].column];
    						//toMakeSuperBall.push([clusterCount, superBallList.length);
    						superBallListIndex.push(superBallList.length);
    						superBallClusterIndex.push(clusterCount);
    						superBallHold1.image = 5;
    						superBallList.push(superBallHold1);
    						//console.log("hit1");
    						//console.log(superBallHold1);
    						continue;
    					}else{
    						if(Object.is(gridShapes[clusters[clusterCount].row + clusterLength][clusters[clusterCount].column], selectBalls[1])){
    							superBallHold1 = gridShapes[clusters[clusterCount].row + clusterLength][clusters[clusterCount].column];
    							//toMakeSuperBall.push([clusterCount, superBallList.length);
    							superBallListIndex.push(superBallList.length);
    							superBallClusterIndex.push(clusterCount);
    							superBallHold1.image = 5;
    							superBallList.push(superBallHold1);
    							//console.log("hit2");
    							//console.log(superBallHold1);

    							continue;
    						}
    					}
    				}
    			}
    			if(Object.is(gridShapes[clusters[clusterCount].row + clusterLength][clusters[clusterCount].column], superBallHold)){
    						//console.log("hit0");
    						continue;
    					}
    					if(Object.is(gridShapes[clusters[clusterCount].row + clusterLength][clusters[clusterCount].column], superBallHold1)){
    						//console.log("hit0");
    						continue;
    					}
    				}
    			}
    			
				var x = 45 * clusters[clusterCount].column;//allShapes[i].x;
				var y = 45 * (clusters[clusterCount].row + clusterLength);//allShapes[i].y;
				if(!screenCleared){
    				//ctx.clearRect(x,y, 45, (45 * clusters[clusterCount].length));
    				screenCleared = true;
    			}
    			ctx.clearRect(x,y, 45, 45);
				var tempImage = gridShapes[clusters[clusterCount].row  + clusterLength][clusters[clusterCount].column].image;//allShapes[i].image;
				if(highlightSize > 50){
					ctx2.globalAlpha = (100 - opacityShift)/100;
				}

				var image1 = document.getElementById("ball" + tempImage);
				ctx2.drawImage(image1, x - (highlightSize/4), y - (highlightSize/4), 45 + (highlightSize/2), 45 + (highlightSize/2));

				ctx2.fillStyle = 'rgba(255,243,179,' + (0 + (highlightSize * 2))/100 + ' )';

				ctx2.beginPath();
				ctx2.arc((45 * clusters[clusterCount].column ) + 22.5 , (45 * (clusters[clusterCount].row + clusterLength)) + 22.5 , 22.5 + (highlightSize/4),0, 2 * Math.PI);
				ctx2.fill();
				
			}
		}
	}
	if(highlightSize >= 59){
		ctx2.globalAlpha = 1;
		//console.log("hit");
		ctx2.clearRect(0,0, c2.width, c2.height);
		opacityShift = 30;
		highlightSize = 1;
		/*
				if(clusters[clusterCount].length === 1 && !foundSuperBallPop){
					foundSuperBallPop = true;
				}
				*/

				for(var clusterCount = 0; clusterCount < clusters.length; clusterCount++){
		// check if includes
		if(clusters[clusterCount].length === 1){
			removeClusters();
			if(!foundSuperBallPop){
				foundSuperBallPop = true;
				//console.log("pop");

				//moveBallList.push([gridShapes[clusters[clusterCount].row][clusters[clusterCount].column].image, 45 * clusters[clusterCount].row, 45 * (clusters[clusterCount].column), false]);			
				
				continue;
			}else{
				continue;
			}
		}
		if(clusters[clusterCount].horizontal){
			moveBallList.push([gridShapes[clusters[clusterCount].row][clusters[clusterCount].column + 1].image, 45 * clusters[clusterCount].row, 45 * (clusters[clusterCount].column + 1), false]);			
		}else{
			moveBallList.push([gridShapes[clusters[clusterCount].row + 1][clusters[clusterCount].column].image, 45 * (clusters[clusterCount].row + 1), 45 * clusters[clusterCount].column, false]);			

		}

	}
	if(!moveBallsToEdgeRunning){
		if(superBallHold !== null){
			//superBallHold.image = 5;
			//superBallList.push(superBallHold);
			//var temp2 = animateSuperBall("superBallSpriteSheet", 720, 720, x , y, 45, 45, 5040, 5040, 33.3, true, false, false, 0);

		}
		if(superBallHold1 !== null){
			//superBallHold.image = 5;
			//superBallList.push(superBallHold);
			//var temp2 = animateSuperBall("superBallSpriteSheet", 720, 720, x , y, 45, 45, 5040, 5040, 33.3, true, false, false, 0);

		}
		
		superBallPopAnimation = false;
		animateThreads = 0;
		moveBallsToEdge();
	}
	superBallPopAnimation = false;
	animateThreads = 0;
	return;
}
if(highlightSize <= 50){
	setTimeout(function(){
		highlightSize+=3;
		//window.requestAnimationFrame(restoreBoard);
		highlightMatch();
		//requestAnimationFrame(highlightMatch);
	}, 15);
}else{
	setTimeout(function(){
		highlightSize+=2;
		opacityShift+=10;
		highlightMatch();
		//requestAnimationFrame(highlightMatch);
	}, 15);
}
}


function highlightMatchSuperBall(superBallTemp){
	var screenCleared = false;
	ctx2.clearRect(0,0, c2.width, c2.height);
	//console.log("highlightSize " + highlightSize);
	//console.log(clusters);
	paused = true;
	var foundSuperBallPop = false;
	var popHelper = function(x, y){
		setTimeout(function(){
			//ctx.clearRect(x,y, 45 , 45);

		}, 100);
	}
	explosionList = [];
	//console.log("highlightMatchSuperBall");
	for(var clusterCount = 0; clusterCount < superBallClusters.length; clusterCount++){
		for(var clusterLength = 0; clusterLength < superBallClusters[clusterCount].length; clusterLength++){
			

			//console.log("matchlength " + superBallClusters[clusterCount].length);
			//console.log(selectBalls);
			if(superBallClusters[clusterCount].horizontal){
				if(superBallClusters[clusterCount].length > 3){
					if(superBallHold === null){
						if(Object.is(gridShapes[superBallClusters[clusterCount].row][superBallClusters[clusterCount].column + clusterLength], selectBalls[0])){
							superBallHold = gridShapes[superBallClusters[clusterCount].row][superBallClusters[clusterCount].column + clusterLength];
							//console.log("hit1");
							continue;
						}else{
							if(Object.is(gridShapes[superBallClusters[clusterCount].row][superBallClusters[clusterCount].column + clusterLength], selectBalls[1])){
								superBallHold = gridShapes[superBallClusters[clusterCount].row][superBallClusters[clusterCount].column + clusterLength];
								//console.log("hit2");
								continue;
							}
						}
					}else{
						if(superBallHold1 === null && gridShapes[superBallClusters[clusterCount].row][superBallClusters[clusterCount].column + clusterLength] !== superBallHold){
							if(Object.is(gridShapes[superBallClusters[clusterCount].row][superBallClusters[clusterCount].column + clusterLength], selectBalls[0])){
								superBallHold = gridShapes[superBallClusters[clusterCount].row][superBallClusters[clusterCount].column + clusterLength];
							//console.log("hit1");
							continue;
						}else{
							if(Object.is(gridShapes[superBallClusters[clusterCount].row][superBallClusters[clusterCount].column + clusterLength], selectBalls[1])){
								superBallHold = gridShapes[superBallClusters[clusterCount].row][superBallClusters[clusterCount].column + clusterLength];
								//console.log("hit2");
								continue;
							}
						}
					}
					if(Object.is(gridShapes[superBallClusters[clusterCount].row][superBallClusters[clusterCount].column + clusterLength], superBallHold)){
							//console.log("hit0");
							continue;
						}
						if(Object.is(gridShapes[superBallClusters[clusterCount].row][superBallClusters[clusterCount].column + clusterLength], superBallHold1)){
							//console.log("hit0");
							continue;
						}
					}
				}
				//ctx.clearRect(x,y, 45 *(superBallClusters[clusterCount].length - 1), 45);

				if(!screenCleared){
					//ctx.clearRect(x,y, (45 * superBallClusters[clusterCount].length), 45);
					screenCleared = true;
				}
				var x = 45 * (superBallClusters[clusterCount].column + clusterLength);//allShapes[i].x;
				var y = 45 * superBallClusters[clusterCount].row;//allShapes[i].y;

				//superBallExplosion

				if(superBallPopAnimation){

					//console.log(superBallClusters);
					/*
					if(animateThreads === 9){
						console.log(explosionList);
						console.log("sendExplosion1");
						var temp2 = animateSuperBallExplosions("ballExplosion", 720, 720, explosionList, 45, 45, 3600, 5760, 80, true, true, true, 200);
						animateThreads++;
						continue;
					}
					*/
					if(animateThreads > 9){
						continue;
					}
					animateThreads++;
					//console.log("animateCheck " + animateThreads);
					//console.log("x " + x);
					//console.log("y " + y);
					//console.log("cluster " + superBallClusters[clusterCount]);
					//explosionList.push([Number(x), Number(y)]);
					explosionList.push([x.toString(), y.toString()]);
					//console.log(explosionList);

					//console.log(explosionList);
					if(explosionList.length === 8){
						//console.log(explosionList);
						//console.log("sendExplosion");
						//superBallPopAnimation = false;//
						//var temp2 = animateSuperBallExplosions("ballExplosion", 720, 720, clusters, 45, 45, 3600, 5760, 80, true, true, true, 200);
						var temp2 = animateSuperBallExplosions("ballExplosion", 240, 240, clusters, 45, 45, 1200, 1200, 50, true, true, true, 200);

						setTimeout(function(){

							animateThreads++;
							moveBallList.push([5, 45 * superBallClusters[0].row, 45 * (superBallClusters[0].column), false]);	

							moveBallsToEdge();
							addScore(1000);

							setTimeout(function(){
								removeClustersSuperBall();
							},200);
							
						}, 100);
						return;
						
					}
					popHelper(x,y);
					continue;




				}
				//ctx.clearRect(x,y, 45 , 45);



				var tempImage = gridShapes[superBallClusters[clusterCount].row][superBallClusters[clusterCount].column + clusterLength].image;//allShapes[i].image;
				if(highlightSize > 50){
					ctx2.globalAlpha = (100 - opacityShift)/100;
				}
				var image1 = document.getElementById("ball" + tempImage);
				ctx2.drawImage(image1, x - (highlightSize/4), y - (highlightSize/4), 45 + (highlightSize/2), 45 + (highlightSize/2));
				//console.log("best highlight1111");
				ctx2.fillStyle = 'rgba(255,243,179,' + (0 + (highlightSize * 2))/100 + ' )';
    			//ctx1.fillRect((45 * superBallClusters[clusterCount].column) + 15, (45 * superBallClusters[clusterCount].row) - 3 , (45 * superBallClusters[clusterCount].length) - 30, 50);
    			ctx2.beginPath();
    			ctx2.arc((45 * (superBallClusters[clusterCount].column + clusterLength)) + 22.5 , (45 * superBallClusters[clusterCount].row) + 22.5 , 22.5 + (highlightSize/4),0, 2 * Math.PI);
    			ctx2.fill();
    		}
    	}
    }
    if(highlightSize >= 59){
    	ctx2.globalAlpha = 1;
		//console.log("hit");
		ctx2.clearRect(0,0, c2.width, c2.height);
		opacityShift = 30;
		highlightSize = 1;
		/*
				if(clusters[clusterCount].length === 1 && !foundSuperBallPop){
					foundSuperBallPop = true;
				}
				*/
				//moveBallList.push([gridShapes[superBallTemp.row][superBallTemp.column + 1].image, 45 * superBallTemp.row, 45 * (superBallTemp.column + 1), false]);
				moveBallList.push([gridShapes[superBallClusters[0].row][superBallClusters[0].column].image, 45 * superBallClusters[0].row, 45 * (superBallClusters[0].column), false]);	
				for(var clusterCount = 0; clusterCount < superBallClusters.length; clusterCount++){
		// check if includes
		if(superBallClusters[clusterCount].length === 1){
			//clusters = [superBallClusters[0]];// superBallClusters;
			//todo
			//removeClustersSuperBall();
			//console.log(clusters);
			//removeClusters();
			if(!foundSuperBallPop){
				foundSuperBallPop = true;
				//console.log("pop");

				//moveBallList.push([gridShapes[superBallClusters[clusterCount].row][superBallClusters[clusterCount].column].image, 45 * superBallClusters[clusterCount].row, 45 * (superBallClusters[clusterCount].column), false]);			
				
				continue;
			}else{
				continue;
			}
		}
		if(superBallClusters[clusterCount].horizontal){
			//moveBallList.push([gridShapes[superBallClusters[clusterCount].row][superBallClusters[clusterCount].column + 1].image, 45 * superBallClusters[clusterCount].row, 45 * (superBallClusters[clusterCount].column + 1), false]);			
		}else{
			//moveBallList.push([gridShapes[superBallClusters[clusterCount].row + 1][superBallClusters[clusterCount].column].image, 45 * (superBallClusters[clusterCount].row + 1), 45 * superBallClusters[clusterCount].column, false]);			

		}

	}
	if(!moveBallsToEdgeRunning){
		superBallList.push(superBallHold);
		if(superBallHold1 !== null){
			superBallList.push(superBallHold);

		}
		superBallPopAnimation = false;
		animateThreads = 0;
		moveBallsToEdge();
	}
	setTimeout(function(){
		addScore(1000);
		//var temp2 = animateSuperBallExplosions("ballExplosion", 720, 720, clusters, 45, 45, 3600, 5760, 100, true, true, true, 200);
		var temp2 = animateSuperBallExplosions("ballExplosion", 240, 240, clusters, 45, 45, 1200, 960, 50, true, true, true, 200);

	},50);
	//removeClusters();


	
	setTimeout(function(){
		removeClustersSuperBall();
	},200);
	return;
}
if(highlightSize <= 50){
	setTimeout(function(){
		highlightSize+=3;
		//window.requestAnimationFrame(restoreBoard);
		requestAnimationFrame(function(){
			highlightMatchSuperBall(superBallTemp);
			//highlightMatchSuperBall(superBallTemp);
		});
	}, 15);
}else{
	setTimeout(function(){
		highlightSize+=2;
		opacityShift+=10;
		
		requestAnimationFrame(function(){
			highlightMatchSuperBall(superBallTemp);
			//highlightMatchSuperBall(superBallTemp);
		});
	}, 15);
}
}
var logCount = 0;
function moveBallsToEdge(){
	moveBallsToEdgeRunning = true;
	edgeOfBoard = true;
	logCount++;
	//console.log("moveBallsToEdge " + logCount);
	for(var moveBallCount = 0; moveBallCount < moveBallList.length; moveBallCount++){
		if(parseFloat(moveBallList[moveBallCount][2]) > 330){
			//console.log("continue");
			if(!moveBallList[moveBallCount][3]){
				addToTimer();
				changeTimerColor = true;
				changeColorEffect2(5, 0, 100);
				
				/*
				if(addToTimerBoolean){
					addToTimer();
					changeTimerColor = true;
					changeColorEffect2(5, 0, 100);
					//flashTimerColor();
					addToTimerBoolean = false;


				}else{
					if(addToTimerBoolean){
					//flashTimer();
					//addToTimerBoolean = false;
				}

			} */
			moveBallList[moveBallCount][3] = true;
			//console.log("flashingMaybe");

		}
		continue;
	}else{
		edgeOfBoard = false;
		multiMatchAnimating = false;

	}
	ctx3.globalAlpha = .85;
	moveBallList[moveBallCount][2]+=4;
				//moveBallList[moveBallCount][1] -= (315 - (315 * ( 1 - timeScale)))/(315 - moveBallList[moveBallCount][2]);  //(315 * (timeScale))/(315 - moveBallList[moveBallCount][2]);
				var yMoveTarget = 315 * ( 1 - timeScale);
				//console.log("yMoveTarget " + yMoveTarget);
				if(moveBallList[moveBallCount][1] < yMoveTarget){
					moveBallList[moveBallCount][1] += ((yMoveTarget - moveBallList[moveBallCount][1])/(315 - moveBallList[moveBallCount][2])) * 2;
				}else{
					moveBallList[moveBallCount][1] -= ((moveBallList[moveBallCount][1] - yMoveTarget)/(315 - moveBallList[moveBallCount][2])) * 2;

				}
				var x = moveBallList[moveBallCount][2];
				var y = moveBallList[moveBallCount][1];

				var image1 = document.getElementById("ball" + moveBallList[moveBallCount][0]);
				ctx3.drawImage(image1, x, y, 30, 30);
			}

			if(edgeOfBoard){
				moveBallsToEdgeRunning = false;
				moveBallList = [];
				//console.log("doneflashing");
				//addToTimerBoolean = true;
				return;
			}

			setTimeout(function(){
				//console.log("moveBallsToEdge1 " + logCount);
				ctx3.clearRect(0,0, c2.width, c2.height);
				requestAnimationFrame(moveBallsToEdge);
			}, 1);

		}
		function swapBallsInGrid(ball1, ball2, checkMatches1) {
	//console.log("swapBallsinGrid");
	var ball1X = ball1.x1,
	ball1Y = ball1.y1,
	ball2X = ball2.x1,
	ball2Y = ball2.y1;
	//console.log("swapBallsinGrid");
	//console.log(gridShapes);
	gridShapes[ball1Y][ball1X] = ball2;
	gridShapes[ball2Y][ball2X] = ball1;

	gridShapes[ball1Y][ball1X].x1 = ball1X;
	gridShapes[ball1Y][ball1X].y1 = ball1Y;
	gridShapes[ball2Y][ball2X].x1 = ball2X;
	gridShapes[ball2Y][ball2X].y1 = ball2Y;
	//console.log(gridShapes);
	//return true;
	var match;
	//console.log("swapBallsinGrid2");
	if(checkMatches1){
		foundSpecialMatch = false;
		//console.log("swapBallsinGrid3");
		findClusters();
		//console.log(clusters);
		if(clusters.length > 0){
		match = true;//checkMatches();

	}else{
		match = false;
	}
		//checkForNewMatches1(0,0); //checkMatches();
		//checkForNewMatches1(0,0); 
		//console.log("match99 " + match);

		return match;
	}

}
/*async*/ function removeClusters(){
		        // Change the type of the tiles to -1, indicating a removed tile
		        //loopClusters(function(index, column, row, cluster) {gridShapes[column][row].image = -1; });
/*
		        clusters.push({ column: column+1-matchlength, row:row,
		        	length: matchlength, horizontal: true });
		        	*/
		        	var toValidateBoard = false;
		        	var skipSuperBall = false;
		        	var horizontalCluster = 0;
		        	for (var i = 0; i < clusters.length; i++) {
		        		//console.log("offset1");
		        		if(clusters[i].horizontal == true){
		        			//console.log("offset2");
		        			for(var j = 0; j < clusters[i].length; j++){
		        				if(false){//clusters[i].row === 0 && clusters[i].length >= 3){
		        					if(selectBalls[0] !== undefined){
		        						if(selectBalls[0].row === 0 && selectBalls[0].column >= clusters[i].column && selectBalls[0].column < (clusters[i].column + clusters[i].length)){
		        							for(var column = clusters[i].column; column < clusters[i].column + clusters[i].length; column++){
		        								if(column === selectBalls[0].column){
		        									continue;
		        								}
		        								var rand = Math.floor((Math.random() * 5));
		        								var temp = new Shape(45 * (clusters[i].column + column),  -45, clusters[i].column + column, 0, rand, 0);
		        								gridShapes[0][clusters[i].column + column] = temp;
		        							}
		        						}
		        						if(selectBalls[1].row === 0 && selectBalls[1].column >= clusters[i].column && selectBalls[1].column < (clusters[i].column + clusters[i].length)){
		        							for(var column = clusters[i].column; column < clusters[i].column + clusters[i].length; column++){
		        								if(column === selectBalls[1].column){
		        									continue;
		        								}
		        								var rand = Math.floor((Math.random() * 5));
		        								var temp = new Shape(45 * (clusters[i].column + column),  -45, clusters[i].column + column, 0, rand, 0);
		        								gridShapes[0][clusters[i].column + column] = temp;
		        							}
		        						}
		        					}
		        				}
		        				//console.log("offset3");
		        				for(var offset = 1; offset < clusters[i].row + 1; offset++){
		        					//superball1

		        					if(superBallList.includes(gridShapes[clusters[i].row][clusters[i].column + j])){
		        						//if(selectBalls[0].ima)
		        						//console.log("foundSuperCluster1");
		        						
		        					}
		        					if(superBallHold !== null){
		        						if(Object.is(gridShapes[clusters[i].row][clusters[i].column + j], superBallHold)){
		        						//if(selectBalls[0].ima)
		        						//console.log("superBallHold5");
		        						toValidateBoard = true;
		        						continue;
		        					}
		        					if(superBallHold1 !== null){
		        						if(Object.is(gridShapes[clusters[i].row][clusters[i].column + j], superBallHold1)){
		        						//if(selectBalls[0].ima)
		        						//console.log("superBallHold6");
		        						toValidateBoard = true;
		        						continue;
		        					}
		        				}

		        			}

		        			gridShapes[clusters[i].row - offset][clusters[i].column + j].y1 += 1; 
		        			gridShapes[clusters[i].row - offset + 1 - horizontalCluster][clusters[i].column + j] = gridShapes[clusters[i].row - offset][clusters[i].column + j];
		        			//gridShapes[clusters[i].row - offset][clusters[i].column + j].y1 += 1; 
		        			//console.log("offset4");
		        		}
		        		var rand = Math.floor((Math.random() * 5));
		        		var temp = new Shape(45 * (clusters[i].column + j),  -45, clusters[i].column + j, 0, rand, 0);
		        		gridShapes[0][clusters[i].column + j] = temp;

		        	}
		        		//horizontalCluster++;

		        	}else{
		        	//for(var j = 0; j < clusters[i].length; j++){
        				//console.log("offset3");
        				var superBallOffset = 0;
    						//superBallListIndex.push(superBallList.length);
    						//superBallClusterIndex.push(clusterCount);
        				if(superBallClusterIndex.includes(i)){//Object.is(gridShapes[clusters[i].row - offset + clusters[i].length - superBallOffset][clusters[i].column], superBallHold)){
        					var index = superBallClusterIndex.indexOf(i);
        					if(index < superBallList.length){
        					//console.log("verticalSuperBall");
        					if(clusters[i].row === 0){
        						//console.log("verticalSuperBall22");

        						
        						gridShapes[clusters[i].row + clusters[i].length - 1][superBallList[superBallListIndex[index]].x1] = gridShapes[superBallList[superBallListIndex[index]].y1][superBallList[superBallListIndex[index]].x1];
        						gridShapes[clusters[i].row + clusters[i].length - 1][superBallList[superBallListIndex[index]].x1].y1 = clusters[i].row + clusters[i].length - 1;

        						var rand = Math.floor((Math.random() * 5));
        						var temp = new Shape(45 * (clusters[i].column),  -45, clusters[i].column, clusters[i].length - 2, rand, 0);
        						gridShapes[clusters[i].length - 2][clusters[i].column] = temp;

        						rand = Math.floor((Math.random() * 5));
        						var temp = new Shape(45 * (clusters[i].column),  -90, clusters[i].column, clusters[i].length - 3, rand, 0);
        						gridShapes[clusters[i].length - 3][clusters[i].column] = temp;

        						if(clusters[i].length === 4){
        							rand = Math.floor((Math.random() * 5));
        							var temp = new Shape(45 * (clusters[i].column),  -135, clusters[i].column, clusters[i].length - 4, rand, 0);
        							gridShapes[clusters[i].length - 4][clusters[i].column] = temp;
        						}
        						if(clusters[i].length === 5){
        							rand = Math.floor((Math.random() * 5));
        							var temp = new Shape(45 * (clusters[i].column),  -180, clusters[i].column, clusters[i].length - 5, rand, 0);
        							gridShapes[clusters[i].length - 5][clusters[i].column] = temp;
        						}
        						if(clusters[i].length === 6){
        							rand = Math.floor((Math.random() * 5));
        							var temp = new Shape(45 * (clusters[i].column),  -225, clusters[i].column, clusters[i].length - 6, rand, 0);
        							gridShapes[clusters[i].length - 6][clusters[i].column] = temp;
        						}
        						continue;
        					}
        					var index = superBallClusterIndex.indexOf(i);
        					//console.log(superBallList[index]);
        					gridShapes[clusters[i].row + clusters[i].length - 1][superBallList[superBallListIndex[index]].x1] = gridShapes[superBallList[superBallListIndex[index]].y1][superBallList[superBallListIndex[index]].x1];
        					gridShapes[clusters[i].row + clusters[i].length - 1][superBallList[superBallListIndex[index]].x1].y1 = clusters[i].row + clusters[i].length - 1;

        					for(var searchY = clusters[i].row - 1; searchY > -1; searchY--){
        						gridShapes[searchY][clusters[i].column].y1 = searchY + clusters[i].length - 1;
        						gridShapes[searchY + clusters[i].length - 1][clusters[i].column] = gridShapes[searchY][clusters[i].column];
        					}

        					for(var fillY = clusters[i].length - 1; fillY > - 1; fillY--){
        						var rand = Math.floor((Math.random() * 5));
        						var temp = new Shape(45 * (clusters[i].column),  -45 * (clusters[i].length - fillY), clusters[i].column, fillY, rand, 0);
        						gridShapes[fillY][clusters[i].column] = temp;
        					}
        					//clusters.splice(i, 1);
        					//i--;
        					//superBallClusterIndex.splice(index, 1);
        					//superBallListIndex.splice(index, 1);


        					//gridShapes[clusters[i].row - offset + clusters[i].length - superBallOffset][clusters[i].column].y1 += offset;
        					//gridShapes[clusters[i].row - offset + clusters[i].length - superBallOffset][clusters[i].column].image = 5;
        					//gridShapes[clusters[i].row + offset][clusters[i].column] = gridShapes[clusters[i].row - offset + clusters[i].length - superBallOffset][clusters[i].column];
        				}

        			}else{
        				for(var offset = 1; offset < clusters[i].row + 1; offset++){
        						if(false){//superBallHold !== null){
        							superBallOffset = 1;
        							if(Object.is(gridShapes[clusters[i].row - offset + clusters[i].length - superBallOffset][clusters[i].column], superBallHold)){
		        						//if(selectBalls[0].ima)
		        						//gridShapes[clusters[i].row - offset + clusters[i].length][clusters[i].column].y1 += offset - 1;
		        						//gridShapes[clusters[i].row - offset + clusters[i].length - superBallOffset][clusters[i].column].y1 += offset;
		        						//gridShapes[clusters[i].row + offset][clusters[i].column].y1 += offset;

		        						gridShapes[clusters[i].row - offset + clusters[i].length - superBallOffset][clusters[i].column].y1 += offset;
		        						gridShapes[clusters[i].row - offset + clusters[i].length - superBallOffset][clusters[i].column].image = 5;
		        						gridShapes[clusters[i].row + offset][clusters[i].column] = gridShapes[clusters[i].row - offset + clusters[i].length - superBallOffset][clusters[i].column];

		        						superBallOffset = clusters[i].length - offset;
		        						//console.log("superBallHold1");
		        						continue;
		        					}
		        					if(Object.is(gridShapes[clusters[i].row - offset + clusters[i].length - superBallOffset][clusters[i].column], superBallHold1)){
		        						//if(selectBalls[0].ima)
		        						//gridShapes[clusters[i].row - offset + clusters[i].length][clusters[i].column].y1 += offset - 1;
		        						//gridShapes[clusters[i].row - offset + clusters[i].length - superBallOffset][clusters[i].column].y1 += offset;
		        						//gridShapes[clusters[i].row + offset][clusters[i].column].y1 += offset;

		        						gridShapes[clusters[i].row - offset + clusters[i].length - superBallOffset][clusters[i].column].y1 += offset;
		        						gridShapes[clusters[i].row - offset + clusters[i].length - superBallOffset][clusters[i].column].image = 5;
		        						gridShapes[clusters[i].row + offset][clusters[i].column] = gridShapes[clusters[i].row - offset + clusters[i].length - superBallOffset][clusters[i].column];

		        						superBallOffset = clusters[i].length - offset;
		        						//console.log("superBallHold1");
		        						continue;
		        					}
		        					if(superBallList.includes(gridShapes[clusters[i].row][clusters[i].column + j])){
		        						//if(selectBalls[0].ima)
		        						//console.log("foundSuperCluster2");
		        						continue;
		        					}
		        				}
		        				gridShapes[clusters[i].row - offset][clusters[i].column].y1 += clusters[i].length; 
		        				gridShapes[clusters[i].row - offset + clusters[i].length - superBallOffset][clusters[i].column] = gridShapes[clusters[i].row - offset][clusters[i].column];
        				//gridShapes[clusters[i].row - offset][clusters[i].column + j].y1 += 1; 
	        			//console.log("offset4");
	        		}

	        		for(var yOffset = clusters[i].length; yOffset > 0; yOffset--){
	        			if(Object.is(gridShapes[clusters[i].length - yOffset][clusters[i].column], superBallHold)){
    						//if(selectBalls[0].ima)
    						//gridShapes[clusters[i].row - offset + clusters[i].length][clusters[i].column].y1 += offset - 1;
    						
    						//console.log("superBallHold2");
    						//continue;
    					}
    					var rand = Math.floor((Math.random() * 5));
    					var temp = new Shape(45 * (clusters[i].column),  -45 * (yOffset - superBallOffset), clusters[i].column, clusters[i].length - yOffset - superBallOffset, rand, 0);
    					gridShapes[clusters[i].length - yOffset - superBallOffset][clusters[i].column] = temp;
    				}

		        	//}
		        }
		    }

		}

		if(!startup){
		    	//console.log("startup " + startup);
		    	//document.getElementById("popSound").play();

		    	superBallListIndex = [];
		    	superBallClusterIndex = [];
		    	if(toValidateBoard){
		    		validateBoard();

		    	}
		    	setTimeout(function(){
		    		superBallHold = null;
		    		superBallHold1 = null;
		    		requestAnimationFrame(massMoveBalls2);


		    	}, 10);
		    }else{

		    	massMoveBalls3();

		    }
		    //console.log(gridShapes);
		    

		    

		    /*
		    clusters = [];

		    findClusters();
		    if(clusters.length > 0){
		    	console.log("multi match");
		    	removeClusters();
		    }
		    */

/*
        // Calculate how much a tile should be shifted downwards
        for (var i = 0; i < 7; i++) {
        	var shift = 0;
        	for (var j = 7; j >= 0; j--) {
                // Loop from bottom to top
                if (level.tiles[i][j].image === -1) {
                    // Tile is removed, increase shift
                    shift++;
                    gridShapes[i][j].shift = 0;
                } else {
                    // Set the shift
                    gridShapes[i][j].shift = shift;
                }
            }
        }

        */
        //restoreBoard();
    }


    function validateBoard(){
    	for(var i = 0; i < clusters.length; i++){
    		for(var searchClusters = 0; searchClusters < clusters.length; searchClusters++){
    			if(clusters[searchClusters].horizontal){
    				if(searchClusters === i){
    					continue;
    				}
    				if(clusters[i].row - 1 === clusters[searchClusters].row){
    					for(var rowCount = clusters[searchClusters].row - 1; rowCount > - 1; rowCount--){
    						gridShapes[rowCount + 1][superBallHold.x1] = gridShapes[rowCount][superBallHold.x1];
    						gridShapes[rowCount + 1][superBallHold.x1].y1++;
    					}
    				}
    			}
    		}
    	}
    	var rand = Math.floor((Math.random() * 5));
    	var temp = new Shape(45 * (superBallHold.x1),  0, superBallHold.x1, 0, rand, 0);
    	//gridShapes[0][clusters[i].column + j] = temp;

    	gridShapes[0][superBallHold.x1] = temp;
    	window.requestAnimationFrame(restoreBoard);
    }


    function removeClustersSuperBall(){
    	var horizontalCluster = 0;
    	var superBallOffset = 0;
    	for (var i = 0; i < clusters.length; i++) {
    		if(clusters[i] === undefined){
    			continue;
    		}
		        		//console.log("offset1");
		        		if(false){
		        			//console.log("offset2");
		        			for(var j = 0; j < clusters[i].length; j++){
		        				//console.log("offset3");
		        				for(var offset = 1; offset < clusters[i].row + 1; offset++){
		        					//superball1

		        					gridShapes[clusters[i].row - offset][clusters[i].column + j].y1 += 1; 
		        					gridShapes[clusters[i].row - offset + 1 - horizontalCluster][clusters[i].column + j] = gridShapes[clusters[i].row - offset][clusters[i].column + j];
		        			//gridShapes[clusters[i].row - offset][clusters[i].column + j].y1 += 1; 
		        			//console.log("offset4");
		        		}
		        		var rand = Math.floor((Math.random() * 5));
		        		var temp = new Shape(45 * (clusters[i].column + j),  -45, clusters[i].column + j, 0, rand, 0);
		        		gridShapes[0][clusters[i].column + j] = temp;

		        	}
		        		//horizontalCluster++;

		        	}
		        	for(var offset = 1; offset < clusters[i].row + 1; offset++){
		        		superBallOffset = 0;
        						if(false){//superBallHold !== null){
        							superBallOffset = 1;
        							if(Object.is(gridShapes[clusters[i].row - offset + clusters[i].length - superBallOffset][clusters[i].column], superBallHold)){
		        						//if(selectBalls[0].ima)
		        						//gridShapes[clusters[i].row - offset + clusters[i].length][clusters[i].column].y1 += offset - 1;
		        						//gridShapes[clusters[i].row - offset + clusters[i].length - superBallOffset][clusters[i].column].y1 += offset;
		        						//gridShapes[clusters[i].row + offset][clusters[i].column].y1 += offset;

		        						gridShapes[clusters[i].row - offset + clusters[i].length - superBallOffset][clusters[i].column].y1 += offset;
		        						gridShapes[clusters[i].row - offset + clusters[i].length - superBallOffset][clusters[i].column].image = 5;
		        						gridShapes[clusters[i].row + offset][clusters[i].column] = gridShapes[clusters[i].row - offset + clusters[i].length - superBallOffset][clusters[i].column];

		        						superBallOffset = clusters[i].length - offset;
		        						//console.log("superBallHold1");
		        						continue;
		        					}
		        					if(superBallList.includes(gridShapes[clusters[i].row][clusters[i].column + j])){
		        						//if(selectBalls[0].ima)
		        						//console.log("foundSuperCluster2");
		        						continue;
		        					}
		        				}
		        				gridShapes[clusters[i].row - offset][clusters[i].column].y1 += clusters[i].length; 
		        				gridShapes[clusters[i].row - offset + clusters[i].length - superBallOffset][clusters[i].column] = gridShapes[clusters[i].row - offset][clusters[i].column];
        				//gridShapes[clusters[i].row - offset][clusters[i].column + j].y1 += 1; 
	        			//console.log("offset4");
	        		}

	        		for(var yOffset = clusters[i].length; yOffset > 0; yOffset--){
	        			if(Object.is(gridShapes[clusters[i].length - yOffset][clusters[i].column], superBallHold)){
    						//if(selectBalls[0].ima)
    						//gridShapes[clusters[i].row - offset + clusters[i].length][clusters[i].column].y1 += offset - 1;
    						
    						//console.log("superBallHold2");
    						//continue;
    					}
    					var rand = Math.floor((Math.random() * 5));
    					var temp = new Shape(45 * (clusters[i].column),  -45 * (yOffset - superBallOffset), clusters[i].column, clusters[i].length - yOffset - superBallOffset, rand, 0);
    					gridShapes[clusters[i].length - yOffset - superBallOffset][clusters[i].column] = temp;
    				}

    			}

    			if(!startup){
		    	//console.log("startup " + startup);
		    	//document.getElementById("popSound").play();
		    	superBallHold = null;
		    	superBallHold1 = null;
		    	//console.log("removeClustersSuperBall");
		    	//todo
		    	clusters = [];
		    	//superBallListIndex = []
		    	setTimeout(function(){
		    		requestAnimationFrame(massMoveBalls2);

		    	}, 250);
		    	
		    }else{

		    	requestAnimationFrame(massMoveBalls3);

		    }


		}
		

		/*async */function massMoveBalls3(){
			const MOVE_SPEED = 5;
			var done = true;

			for(var y3 = 0; y3 < 8; y3++){
				for(var x3 = 0; x3 < 8; x3++){
					if(gridShapes[y3][x3].y != gridShapes[y3][x3].y1 *(45)){
						gridShapes[y3][x3].y += MOVE_SPEED;
						done = false;
					}
				}
			}


			toMove = true;
			updateMassMoveBalls = true;
			if (done) {

				selectBalls = [];
				breakBall1 = [];
				breakBall2 = [];
				toMove = false;

				foundSpecialMatch = false;
			//checkForNewMatches1(0,0);
			setTimeout(function(){
				document.getElementById("preventInput").style.display = "none";
			}, 200);
			//console.log("moveBalls2Done");
			//debugger;
			//resolve();
			clusters = [];

			findClusters();
			if(clusters.length > 0){

				//console.log("multi match");
				//console.log("startup " + startup);

				if(!startup){
					//console.log("startup11 " + startup);
					//document.getElementById("popSound").play();
					//var comboAnimation = document.getElementById("comboMessage");
					
					if(!comboAnimating){
						comboAnimating = true;
						document.getElementById("comboMessage").style.animationName = 'comboMessageAnimation';
						comboAnimating = false;
						setTimeout(function(){
							document.getElementById("comboMessage").style.animationName = 'none';
						}, 1000);
					}




					multiMatch = true;


				}
				//tempFiller2
				removeClusters();
			}else{
				//multiMatch = false;
				chainScore = 0;
			}
			return;
		}
		window.requestAnimationFrame(restoreBoard);
				//await(promiseRAF());
				window.requestAnimationFrame(massMoveBalls3);
		//massMoveBalls2();
	}



	function massMoveBalls2(){
		const MOVE_SPEED = 5;
		var done = true;

		for(var y3 = 0; y3 < 8; y3++){
			for(var x3 = 0; x3 < 8; x3++){
				if(gridShapes[y3][x3].y != gridShapes[y3][x3].y1 *(45)){
					gridShapes[y3][x3].y += MOVE_SPEED;
					done = false;
				}
			}
		}


		toMove = true;
		updateMassMoveBalls = true;
		if (done) {

			selectBalls = [];
			breakBall1 = [];
			breakBall2 = [];
			toMove = false;

			foundSpecialMatch = false;
			//checkForNewMatches1(0,0);
			/* can click tester
			setTimeout(function(){
				document.getElementById("preventInput").style.display = "none";
			console.log("canClick0");

			}, 200);
			*/
			//console.log("moveBalls2Done");
			//debugger;
			//resolve();
			clusters = [];

			findClusters();
			if(clusters.length > 0){

				//console.log("multi match");
				//console.log("startup " + startup);

				if(!startup){
					//console.log("startup11 " + startup);
					//document.getElementById("popSound").play();
					//var comboAnimation = document.getElementById("comboMessage");
					
					if(!comboAnimating){
						comboAnimating = true;
						document.getElementById("comboMessage").style.animationName = 'comboMessageAnimation';
						comboAnimating = false;
						setTimeout(function(){
							document.getElementById("comboMessage").style.animationName = 'none';
						}, 1000);
					}




					multiMatch = true;


				}
				//tempFiller2
				//removeClusters();
				requestAnimationFrame(highlightMatch);
				setTimeout(function(){
					ctx.globalAlpha = 1;
					ctx1.clearRect(0,0, c1.width, c1.height);
					//ctx2.clearRect(0,0, c2.width, c2.height);
					removeClusters();
					/*
					var timeScaleTemp = 0.12 + (level * 0.02);
					if(timeScaleTemp > 0.20){
						timeScaleTemp = 0.20;
					}
					timeScale += timeScaleTemp;
					*/
	//canClick = true;

}, 600);
			}else{
				//multiMatch = false;
				chainScore = 0;
				superBallClusterIndex = [];
				setTimeout(function(){
					document.getElementById("preventInput").style.display = "none";
					//multiMatch = false;
					paused = false;
				}, 100);
			}
			return;
		}
		window.requestAnimationFrame(restoreBoard);
				//await(promiseRAF());
				window.requestAnimationFrame(massMoveBalls2);
		//massMoveBalls2();
	}

	function addScore(points){
		if(!document.getElementById("popSound").playing){
			if(!mute){
				document.getElementById("popSound").play();		
			}
		}else{
			if(!mute){
				document.getElementById("popSound").pause();
				document.getElementById("popSound").currentTime = 0;
				document.getElementById("popSound").play();
			}
			
		}
		score += points;
		document.getElementById("score").innerHTML = "Score: " + score;
	}

	function updateAllShapes(){
		allShapes = [];
		for(var x4 = 0; x4 < 8; x4++){
			for(var y4 = 0; y4 < 8; y4++){
				allShapes.push(gridShapes[y4][x4]);
			}
		}
	}
	/*async */function checkForNewMatches(index){
		//console.log("newBallsToMatch3");
		//console.log(allShapes);
		window.requestAnimationFrame(checkMatchSingle(allShapes[index]));
		//await checkMatchSingle(allShapes[index]);
		if(index + 1 < allShapes.length){
			checkForNewMatches(index + 1);
		}else{
			newBallsToMatch = [];
		} 
	}

	function showHelp(){
		//console.log("aaaaaaa");
		document.getElementById("waitState").style.display = "block";
		document.getElementById("information").style.display = "block";
		document.getElementById("play1").style.display = "block";
		paused = true;
		document.getElementById('mainGame').style.display = 'block';
		document.getElementById('mainMenu').style.display = 'none';
		return;
	}

	function returnPlay(){
		paused = false;
		//changeScreen();
		//document.getElementById("mainGame").classList.remove("mainGameBackground");
		document.getElementById('gameOverScreen').style.display = 'none';
		document.getElementById('mainMenu').style.display = 'none';
		document.getElementById('mainGame').style.display = 'block';
		document.getElementById('waitState').style.display = 'none';
		document.getElementById("play1").style.display = "none";
		document.getElementById("information").style.display = "none";

		if(!firstPlayCheck){
			document.getElementById("popSound").play();
			document.getElementById("popSound").pause();
			firstPlayCheck = true;
			//setTimeout(changeScreen,100);
			var mainTheme = document.getElementById("maintheme");
			maintheme.volume = .35;
			maintheme.play();
			maintheme.loop = true;
			setTimeout(function(){
				startup = false;
 			//console.log("firstPlay");
 			score = 0;
 			document.getElementById("score").innerHTML = "Score: " + score;
 			doTimer();
 		},100);
		}

		//doDebug();
		start = false;
		startup = false;
		paused = false;

	}

	//finish flash timer

	function flashTimer(){
		var fadeTarget = document.getElementById("timer");
		
		//console.log("fadingcall22222 " + fading);
		var flashCount = 0;

		constantFlashingTimer = true;
		fadeOutEffect(fadeTarget, -1, 0, 35);

		//fadeOutEffect;
/*
		var fadeInEffect = setInterval(function () {
			if (!fadeTarget.style.opacity) {
				fadeTarget.style.opacity = 1;
			}
			if (fadeTarget.style.opacity > 0) {
				fadeTarget.style.opacity -= 0.1;
			} else {
				clearInterval(fadeOutEffect);
			}
		}, 50);
		*/

	}

	function flashTimerColor(){


		var colorChanger = setInterval(function(){
			if(changeTimerColor){
				changeTimerColor = false;
			}else{
				changeTimerColor = true;
			}

			changeColorCounter++;
			if(changeColorCounter > 10){
				clearInterval(colorChanger);
				changeColorCounter = 0;
				changeTimerColor = false;
			}

			//console.log("interval");
		}, 40);
	}



	var greenOffset = (timerColor[1] * timeScale) - 20;
	greenOffset += 80 * (timeScale);

	var redOffset = ( 255 * (1 - timeScale)); 
	redOffset += 50 * (1 - timeScale);

	if(redOffset > 255){
		redOffset = 255;
	}
	if(greenOffset > 255){
		greenOffset = 255;
	}
	if(greenOffset < 0){
		greenOffset = 0;
	}

	if(!changeTimerColor){
		document.getElementById("timer").style.background = 'rgb(' +  redOffset + ',' + greenOffset + ',0)';
	}
	function changeColorEffect1(fadeTarget, flashMax, flashCount, interval){
		var fading = true;
		var doFadeOut = setInterval(function () {
			if (!fadeTarget.style.opacity) {
				fadeTarget.style.opacity = 1;
			}
			if(fading){
				if (fadeTarget.style.opacity > 0) {
					fadeTarget.style.opacity -= 0.1;
				}else{
					fading = false;
					clearInterval(doFadeOut);
					if(flashMax !== 0){
						changeColorEffect2(fadeTarget, flashMax, flashCount, interval);
					}
				}
			}
		}, interval);

	}

	function changeColorEffect2(flashMax, flashCount, interval){
		var fading = true;
		//var fadeNumber = fadeTarget.style.opacity;
		var changeColor = setInterval(function () {
			var greenOffset = (timerColor[1] * timeScale) - 20;
			greenOffset += 80 * (timeScale);

			var redOffset = ( 255 * (1 - timeScale)); 
			redOffset += 50 * (1 - timeScale);

			if(redOffset > 255){
				redOffset = 255;
			}
			if(greenOffset > 255){
				greenOffset = 255;
			}
			if(greenOffset < 0){
				greenOffset = 0;
			}
			if(flashCount % 2 === 0){
				document.getElementById("timer").style.background = 'rgb(' +  redOffset + ',' + greenOffset + ',0)';
			}else{
				document.getElementById("timer").style.background = 'white';
			}

			if (flashCount > flashMax) {
				document.getElementById("timer").style.background = 'rgb(' +  redOffset + ',' + greenOffset + ',0)';
				clearInterval(changeColor);
				changeTimerColor = false;
			}
			flashCount++;
		}, interval);
	}

	function fadeOutEffect(fadeTarget, flashMax, flashCount, interval){
		var fading = true;
		var doFadeOut = setInterval(function () {
			if (!fadeTarget.style.opacity) {
				fadeTarget.style.opacity = 1;
			}
			if(fading){
				if (fadeTarget.style.opacity > 0) {
					fadeTarget.style.opacity -= 0.1;
				}else{
					fading = false;
					clearInterval(doFadeOut);
					if(flashMax !== 0){
						fadeInEffect(fadeTarget, flashMax, flashCount, interval);
					}
				}
			}
		}, interval);

	}

	function fadeInEffect(fadeTarget, flashMax, flashCount, interval){
		var fading = true;
		var fadeNumber = fadeTarget.style.opacity;
		var doFadeIn = setInterval(function () {

			if (fadeTarget.style.opacity < 1) {
				fadeNumber = parseFloat(fadeNumber) + parseFloat('0.1');
				fadeTarget.style.opacity = fadeNumber;
					//console.log("fadingUp " + fadeNumber);
				}else{
					//console.log("fadingcall " + fading);
					clearInterval(doFadeIn);
					if(!constantFlashingTimer && flashMax === -1){
						return;
					}
					if((flashCount < flashMax) || flashMax === -1){
						fadeOutEffect(fadeTarget, flashMax, flashCount + 1, interval);
					}

				}
			}, interval);
	}
	function findClusters(){
	    // Find horizontal clusters
	    var foundSuperBall = false;
	    for (var row = 0; row < 8; row++) {
            // Start with a single tile, cluster of 1
            var matchlength = 1;
            for (var column = 0; column < 8; column++) {
            	var checkcluster = false;

            	if (column == 7) {
                    // Last tile
                    checkcluster = true;
                } else {
                    // Check the type of the next tile
                    if (gridShapes[row][column].image === gridShapes[row][column+1].image &&
                    	gridShapes[row][column].image != -1 && gridShapes[row][column].image != 5) {
                        // Same type as the previous tile, increase matchlength
                    matchlength += 1;
                    //console.log("findingClusters");
                    //console.log(findClusters.caller);
                    //console.log(gridShapes[row][column].image);
                } else {
                        // Different type
                        checkcluster = true;
                    }
                }

                // Check if there was a cluster
                if (checkcluster) {
                	//console.log("vertClusterCheck");
                	if (matchlength >= 3) {
                        // Found a horizontal cluster
                       // console.log("vertClusterMatch");
                       clusters.push({ column: column+1-matchlength, row:row,
                       	length: matchlength, horizontal: true });
                       //console.log("preAddScore1");
                       if(!startup){
                       	//console.log("preAddScore2");
                       	addScore(matchlength * (40 + (level * 20))) ;
                       	chainScore += matchlength * (40 + (level * 20));
                       	//console.log("scoreMEssage " + clusters[0].row);



                       	if(clusters[0].row >= 5){
                       		//document.getElementById("scoreMessage").style.top = "55%";
                       	}
                       	if(!multiMatch){
                       		//addToTimerBoolean = true;
                       		//flashTimer();
                       	}
                       	for(var clusterLength = 0; clusterLength < clusters.length; clusterLength++){
                       		if(startup){
                       			break;
                       		}
                       		switch(clusters[clusterLength].row){
                       			case 0:
                       			document.getElementById("scoreMessage").style.top = "0%";
                       			break;
                       			case 1:
                       			document.getElementById("scoreMessage").style.top = "7%";
                       			break;
                       			case 2:
                       			document.getElementById("scoreMessage").style.top = "10%";
                       			break;
                       			case 3:
                       			document.getElementById("scoreMessage").style.top = "20%";
                       			break;
                       			case 4:
                       			document.getElementById("scoreMessage").style.top = "30%";
                       			break;
                       			case 5:
                       			document.getElementById("scoreMessage").style.top = "45%";
                       			break;
                       			case 6:
                       			document.getElementById("scoreMessage").style.top = "55%";
                       			break;
                       			case 7:
                       			document.getElementById("scoreMessage").style.top = "70%";
                       			break;
                       			default:
                       			document.getElementById("scoreMessage").style.top = "0%";
                       			break;
                       		}



                       		switch(clusters[clusterLength].column){
                       			case 0:
                       			document.getElementById("scoreMessage").style.left = "-80%";
                       			break;
                       			case 1:
                       			document.getElementById("scoreMessage").style.left = "-60%";
                       			break;
                       			case 2:
                       			document.getElementById("scoreMessage").style.left = "-40%";
                       			break;
                       			case 3:
                       			document.getElementById("scoreMessage").style.left = "-20%";
                       			break;
                       			case 4:
                       			document.getElementById("scoreMessage").style.left = "10%";
                       			break;
                       			case 5:
                       			document.getElementById("scoreMessage").style.left = "30%";
                       			break;
                       			case 6:
                       			document.getElementById("scoreMessage").style.left = "55%";
                       			break;
                       			case 7:
                       			document.getElementById("scoreMessage").style.left = "70%";
                       			break;
                       			default:
                       			document.getElementById("scoreMessage").style.left = "0%";
                       			break;
                       		}
                       		//console.log("top " + document.getElementById("scoreMessage").style.top);
                       		if(clusters[clusterLength].horizontal){
                       			document.getElementById("scoreMessage").style.left = parseFloat(document.getElementById("scoreMessage").style.left) + 25 + '%';
                       			if(clusters[clusterLength].length > 3){
                       				document.getElementById("scoreMessage").style.left = parseFloat(document.getElementById("scoreMessage").style.left) + 10 + '%';
                       			}
                       		}
                       		document.getElementById("scoreMessage").innerHTML = chainScore + " points";
                       		if(!scoreAnimating){
                       			scoreAnimating = true;
                       			document.getElementById("scoreMessage").innerHTML = chainScore + " points";
                       			document.getElementById("scoreMessage").style.animationName = 'comboMessageAnimation';
                       			setTimeout(function(){
                       				scoreAnimating = false;
                       				document.getElementById("scoreMessage").style.animationName = 'none';
                       				document.getElementById("scoreMessage").style.top = "0%";
                       			}, 1000);
                       		}
                       	}
                       	chainCount++;

                       }
                   }

                   matchlength = 1;
               }
           }
       }


// Find vertical clusters
for (var column = 0; column < 8; column++) {
            // Start with a single tile, cluster of 1
            var matchlength = 1;
            for (var row = 0; row < 8; row++) {
            	var checkcluster = false;

            	if (row === 7) {
                    // Last tile
                    checkcluster = true;
                } else {
                    // Check the type of the next tile
                    if (gridShapes[row][column].image === gridShapes[row+1][column].image &&
                    	gridShapes[row][column].image != -1) {
                        // Same type as the previous tile, increase matchlength
                    matchlength += 1;
                } else {
                        // Different type
                        checkcluster = true;
                    }
                }

                // Check if there was a cluster
                if (checkcluster) {
                	//.console.log("horizontalClusterCheck");
                	if (matchlength >= 3) {
                		//console.log("horizontalClusterMatch");
                        // Found a vertical cluster
                        clusters.push({ column: column, row:row+1-matchlength,
                        	length: matchlength, horizontal: false });
                        //console.log("testCluster");
                        //console.log(clusters);
                        //console.log("preAddScore3");
                        if(!startup){
                        	//console.log("preAddScore4");
                        	addScore(matchlength * (40 + (level * 20))) ;
                        	chainScore += matchlength * (40 + (level * 20));
                        	//console.log("scoreMEssage " + clusters[0].row);

                        	for(var clusterLength = 0; clusterLength < clusters.length; clusterLength++){
                       		//console.log("top" + (20 + clusters[clusterLength].row).toString() + "%");

                       		//document.getElementById("scoreMessage").style.top = (clusters[clusterLength].row * 5).toString() + "%";
                       		if(!multiMatch){
	                       		//flashTimer();
	                       		//addToTimerBoolean = true;
	                       	}
	                       	if(startup){
	                       		break;
	                       	}
	                       	switch(clusters[clusterLength].row){
	                       		case 0:
	                       		document.getElementById("scoreMessage").style.top = "0%";
	                       		break;
	                       		case 1:
	                       		document.getElementById("scoreMessage").style.top = "7%";
	                       		break;
	                       		case 2:
	                       		document.getElementById("scoreMessage").style.top = "10%";
	                       		break;
	                       		case 3:
	                       		document.getElementById("scoreMessage").style.top = "20%";
	                       		break;
	                       		case 4:
	                       		document.getElementById("scoreMessage").style.top = "30%";
	                       		break;
	                       		case 5:
	                       		document.getElementById("scoreMessage").style.top = "45%";
	                       		break;
	                       		case 6:
	                       		document.getElementById("scoreMessage").style.top = "55%";
	                       		break;
	                       		case 7:
	                       		document.getElementById("scoreMessage").style.top = "70%";
	                       		break;
	                       		default:
	                       		document.getElementById("scoreMessage").style.top = "0%";
	                       		break;
	                       	}




	                       	switch(clusters[clusterLength].column){
	                       		case 0:
	                       		document.getElementById("scoreMessage").style.left = "-80%";
	                       		break;
	                       		case 1:
	                       		document.getElementById("scoreMessage").style.left = "-60%";
	                       		break;
	                       		case 2:
	                       		document.getElementById("scoreMessage").style.left = "-40%";
	                       		break;
	                       		case 3:
	                       		document.getElementById("scoreMessage").style.left = "-20%";
	                       		break;
	                       		case 4:
	                       		document.getElementById("scoreMessage").style.left = "10%";
	                       		break;
	                       		case 5:
	                       		document.getElementById("scoreMessage").style.left = "30%";
	                       		break;
	                       		case 6:
	                       		document.getElementById("scoreMessage").style.left = "55%";
	                       		break;
	                       		case 7:
	                       		document.getElementById("scoreMessage").style.left = "70%";
	                       		break;
	                       		default:
	                       		document.getElementById("scoreMessage").style.left = "0%";
	                       		break;
	                       	}


	                       	if(clusters[clusterLength].horizontal){
	                       		document.getElementById("scoreMessage").style.left = parseFloat(document.getElementById("scoreMessage").style.left) + 25 + '%';
	                       		if(clusters[clusterLength].length > 3){
	                       			document.getElementById("scoreMessage").style.left = parseFloat(document.getElementById("scoreMessage").style.left) + 10 + '%';
	                       		}
	                       	}

	                       	//console.log("top " + document.getElementById("scoreMessage").style.top);

	                       	document.getElementById("scoreMessage").innerHTML = chainScore + " points";
	                       	if(!scoreAnimating){
	                       		scoreAnimating = true;

	                       		if(clusters[0].row >= 5){
                        			//document.getElementById("scoreMessage").style.top = "55%";
                        		}
                        		document.getElementById("scoreMessage").innerHTML = chainScore + " points";
                        		document.getElementById("scoreMessage").style.animationName = 'comboMessageAnimation';
                        		setTimeout(function(){
                        			scoreAnimating = false;
                        			document.getElementById("scoreMessage").style.animationName = 'none';
                        			document.getElementById("scoreMessage").style.top = "0%";
                        		}, 1000);
                        	}
                        }
                        chainCount++;

                    }
                }

                matchlength = 1;
            }
        }
    }


}


function findHint(){
	//levelComplete();
	//var temp2 = animateScript("ballExplosion", 720, 720, 90, 90, 45, 45, 3600, 5760, 33.3, true);

	//return;
	//console.log("findingHint");

	//restoreBoard1();
	/*
	gridShapes[2][1].image = 1;
	gridShapes[2][2].image = 0;
	gridShapes[2][3].image = 1;
	gridShapes[2][4].image = 1;

	gridShapes[1][1].image = 0;
	gridShapes[1][2].image = 1;
	gridShapes[1][3].image = 0;
	restoreBoard();
	return;
	*/
	if(paused || pausedButtonActive){
		return;
	}
	showingHint = true;
	var lastBall = null;
	    // Find horizontal clusters
	    for (var row = 0; row < 8; row++) {
            // Start with a single tile, cluster of 1
            var matchlength = 1;
            for (var column = 0; column < 8; column++) {
            	if (column == 7) {
                    // Last tile
                } else {
                    // Check the type of the next tile
                    if (gridShapes[row][column].image === gridShapes[row][column+1].image &&
                    	gridShapes[row][column].image != -1) {
                        // Same type as the previous tile, increase matchlength
                    matchlength += 1;
                } else {
                        // Different type
                        if(matchlength == 2){
                        	if(column + 2 < 8){
                        		if (gridShapes[row][column-1].image === gridShapes[row][column+2].image &&
                        			gridShapes[row][column].image != -1) {
                        // Same type as the previous tile, increase matchlength
                    //console.log("hintCheck");
                    //console.log(gridShapes[row][column]);
                    //console.log("hintCheck1");
                    showHint(gridShapes[row][column+2]);
                    return;
                } 
            }

            if(column - 3 > -1){
            	if (gridShapes[row][column-1].image === gridShapes[row][column-3].image &&
            		gridShapes[row][column].image != -1) {
                        // Same type as the previous tile, increase matchlength
                    //console.log("hintCheck2");
                    showHint(gridShapes[row][column-3]);
                    return;
                } 
            }
            if(row + 1 < 8){
            	if (gridShapes[row][column].image === gridShapes[row+1][column+1].image &&
            		gridShapes[row][column].image != -1) {
                        // Same type as the previous tile, increase matchlength
                    //console.log("hintCheck");
                    //console.log(gridShapes[row][column]);
                    //console.log("hintCheck2_1");
                    showHint(gridShapes[row+1][column+1]);
                    return;
                } 
            }

            if(row - 1 > -1){
            	if (gridShapes[row][column ].image === gridShapes[row-1][column+1].image &&
            		gridShapes[row][column].image != -1) {
                        // Same type as the previous tile, increase matchlength
                    //console.log("hintCheck2_2");
                    showHint(gridShapes[row-1][column+1]);
                    return;
                } 
            }
        }
        matchlength = 1;
    }
}

}
}


// Find vertical clusters
for (var column = 0; column < 8; column++) {
            // Start with a single tile, cluster of 1
            var matchlength = 1;
            for (var row = 0; row < 8; row++) {
            	if (row === 7) {
                    // Last tile
                } else {
                    // Check the type of the next tile
                    if (gridShapes[row][column].image === gridShapes[row+1][column].image &&
                    	gridShapes[row][column].image != -1) {
                        // Same type as the previous tile, increase matchlength
                    matchlength += 1;
                } else {
                        // Different type
                        if(matchlength == 2){
                        	if(row + 2 < 8){
                        		if (gridShapes[row-1][column].image === gridShapes[row + 2][column].image &&
                        			gridShapes[row+2][column].image != -1) {
                        // Same type as the previous tile, increase matchlength
                    //console.log("")
                    //console.log("hintCheck3");
                    showHint(gridShapes[row + 2][column], 0, true);
                    return;
                } 
            }

            if(row - 2 > -1){
            	if (gridShapes[row][column].image === gridShapes[row - 2][column].image &&
            		gridShapes[row][column].image != -1) {
                        // Same type as the previous tile, increase matchlength
                    //console.log("hintCheck4");
                    showHint(gridShapes[row - 2][column], 0, true);
                    return;
                } 
            }
        }
        if(matchlength == 2){
        	if(column + 2 < 8){
        		if (gridShapes[row][column].image === gridShapes[row][column + 2].image &&
        			gridShapes[row][column].image != -1) {
                        // Same type as the previous tile, increase matchlength
                    //console.log("hintCheck5");
                    showHint(gridShapes[row][column + 2], 0, true);
                    return;
                } 
            }

            if(column - 2 > -1){
            	if (gridShapes[row][column].image === gridShapes[row][column - 2].image &&
            		gridShapes[row][column].image != -1) {
                        // Same type as the previous tile, increase matchlength
                    //console.log("hintCheck6");
                    showHint(gridShapes[row][column - 2], 0, true);
                    return;
                } 
            }
        }

        if(matchlength == 1){
        	if(column + 2 < 8){
        		if (gridShapes[row][column].image === gridShapes[row][column + 2].image &&
        			gridShapes[row][column].image != -1) {
        			if(row + 1 < 8){
        				if (gridShapes[row][column].image === gridShapes[row + 1][column + 1].image &&
        					gridShapes[row][column].image != -1) {
                        // Same type as the previous tile, increase matchlength
                    //console.log("hintCheck7");
                    showHint(gridShapes[row + 1][column + 1], 0, true);
                    return;
                }
                if(row - 1 > 0){
                	if (gridShapes[row][column].image === gridShapes[row - 1][column + 1].image &&
                		gridShapes[row][column].image != -1) {
                        // Same type as the previous tile, increase matchlength
                    //console.log("hintCheck8");
                    showHint(gridShapes[row - 1][column + 1], 0, true);
                    return;
                }
            }
        } 
    }

    if(column - 2 > -1){
    	if (gridShapes[row][column].image === gridShapes[row][column - 2].image &&
    		gridShapes[row][column].image != -1) {
    		if(row + 1 < 8){
    			if (gridShapes[row][column].image === gridShapes[row + 1][column - 1].image &&
    				gridShapes[row][column].image != -1) {
                        // Same type as the previous tile, increase matchlength
                    //console.log("hintCheck9");
                    showHint(gridShapes[row + 1][column - 1], 0, true);
                    return;
                }
                if(row - 1 > 0){
                	if (gridShapes[row][column].image === gridShapes[row - 1][column - 1].image &&
                		gridShapes[row][column].image != -1) {
                        // Same type as the previous tile, increase matchlength
                    //console.log("hintCheck10");
                    showHint(gridShapes[row - 1][column - 1], 0, true);
                    return;
                }
            }
        } 
    }
} 
}
}



}
}

}
}


}

function showHint(ball){
		//tx.fillStyle= "rba(255,255, 0.5)";
		//ctx.fillRect(ball.x1, ball.y1, 45, 45);
		//requestAnimationFrame(restoreBoard);
		//console.log("showingHintHighlight");
		//console.log(ball);
/*
		gridShapes[1][1].image = 1;
		gridShapes[2][1].image = 1;
		gridShapes[3][1].image = 2;
		gridShapes[4][1].image = 1;

		gridShapes[1][2].image = 2;
		gridShapes[2][2].image = 2;
		gridShapes[3][2].image = 1;
		gridShapes[4][2].image = 2;

		restoreBoard();

		return;
		*/

		selectBalls = [];
		var rising = true;
		var opacity = 1;
		selectBalls.push(gridShapes[ball.y1][ball.x1]);

		tempButtons[ball.x1 + (ball.y1 * 8) ].focus();
		selectBalls = [ball];
		if(timeScale - .05 <= 0)
		{
			timeScale = 0.005;
		}else{
			timeScale -=.05;

		}
		if(pulseHint !== undefined){
			clearInterval(pulseHint);
		}
		pulseHint = setInterval(function () {
			ctx1.clearRect(0, 0, c1.width, c1.height);
			ctx1.globalAlpha = opacity;
			//ctx.fillStyle= "rba(255,255, " + opacity + ")";

			ctx1.fillStyle = highlightColor;
			ctx1.strokeStyle = highlightColor;

			//console.log("showingHint1");
			ctx1.beginPath();
			ctx1.arc((45 * ball.x1) + 22.5, (45 * ball.y1) + 22.5, 24,0, 2 * Math.PI);
			ctx1.stroke();
			
			//ctx.fillRect(ball.x1, ball.y1, 45, 45);
			if(rising){
				if(opacity < 1){
					opacity += .1;
				}else{
					rising = false;
				}
			}else{
				if(opacity > 0){
					opacity -= .1;
				}else{
					rising = true;
				}
			}

			if(!showingHint || timeScale <= .01){
				clearInterval(pulseHint);
				ctx1.globalAlpha = 1;

				return;
			}
		}, 50);


	}

	function startReadingLink(){
		//console.log("reading " + gameType);
		var link;
		switch(gameType){
			case "game0":
			link = "https://www.shelfstuff.com/book-shelf/books/wild-rescuers-guardians-of-the-taiga?id=9780062796370";
			break;
			case "game1":
			link = "https://www.shelfstuff.com/#/book-shelf/books/voyage-of-the-dogs?id=9780062686008";
			break;

			case "game2":
			link = "https://www.shelfstuff.com/book-shelf/books/tbh-1-tbh-this-is-so-awkward?id=9780062689900";
			break;
			case "game3":
			link = "https://www.shelfstuff.com/book-shelf/books/popularmmos-presents-a-hole-new-world?id=9780062790873";
			break;

			case "game4":
			link = "https://www.shelfstuff.com/book-shelf/books/bravelands-1-broken-pride?id=9780062642028";
			break;

			case "game5":
			link = "https://www.shelfstuff.com/book-shelf/books/the-school-for-good-and-evil-5-a-crystal-of-time/";
			break;			

			case "game6":
			link = "https://www.shelfstuff.com/book-shelf/books/just-jaime/";
			break;
			
			default:
			link = "https:www.shelfstuff.com/book-shelf/books";
			break;
		}
		var win = window.open(link, '_blank');
		win.focus();
	}

	function endDrag(event){
		if(lastTouch === null){
			return;
		}

		disableScolling = false;
		touchPositions[1] = [lastTouch.touches[0].clientX, lastTouch.touches[0].clientY ];
		//console.log(touchPositions[1]);
		ballButton = document.elementFromPoint(Math.round(lastTouch.touches[0].clientX), Math.round(lastTouch.touches[0].clientY));
		document.elementFromPoint(Math.round(lastTouch.touches[0].clientX), Math.round(lastTouch.touches[0].clientY)).click();
		//console.log(document.elementFromPoint(Math.round(lastTouch.touches[0].clientX), Math.round(lastTouch.touches[0].clientY)));
		lastTouch = null;
	}

	function trackTouch(event){
		if(disableScolling){
			event.preventDefault();
		}
		lastTouch = event;
	}